/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################


																
/*
#ifdef __GNUG__
/// #pragma implementation
#endif

/// For compilers that support precompilation, includes "wx.h".
//#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
*/

///#######################################################################
///
///#######################################################################



#ifndef BSMART_SERVER_H
#define BSMART_SERVER_H



#if 0
	#pragma warning (disable: 4100 4512 4244 4267)				   //roland

	#include <boost/archive/binary_oarchive.hpp>					  //must be included before other serialization headers

	#pragma warning (default: 4100 4512 4244 4267)				   //roland


	//#include <ostream>
	#include <sstream>
	//#include <fstream>
#endif



/*
void save_innercells_data(const CHART_DATA_STRUCT_A &data_out) 
{
	std::ofstream ofs("net_assoc_lines.dat");
	boost::archive::binary_oarchive oa(ofs);
	oa << data_out;
}
  */











#include "../clientserver/server/myServer.h"



//namespace ai
//{
	#include "datastructures/chart_datastructures.h"					//chart data structures
//};





#if 0	 ///moved to server_stdafx.h

	#define NOMACROS
	#define INCLUDE_WINDOWS_H
	#include "../pdcurses/curses.h"
	#undef NOMACROS



	#include <sstream>
	#include <iomanip>			///setprecision

#endif	  ///moved to server_stdafx.h





//#include "Controller.h"
//namespace ai
//{
	#include "tasand1_echo_lines/echo_lines.h"								   //its good idea to include this as last include, because it defines mutiple shortcut definitions that might conflict with other headers otherwise
	#include "datastructures/status_vector.h"
//};

//#include "Controller3DDrawing.h"
//#include <Platform/OpenGL.h>


//#include "Win32Application/MSchartDemo/stdafx.h"
//#include "Win32Application/MSchartDemo/TDS_chart.h"






#define USE_NET					1



#define STATUSES			\
							\
	TURN_LEFT,				\
	TURN_RIGHT,				\
	STRAIGHT,				\
	STOP,					\
	BACKWARDS_STRAIGHT,		\
	WAIT_FOR_START


enum
{
	//STATUSES
	STATUS_TABLE_BEGINNING = -1,
	
	TURN_LEFT,				
	TURN_RIGHT,				
	STRAIGHT,				
	STOP,					
	//BACKWARDS_STRAIGHT,		
	WAIT_FOR_START,
	
	STATUS_TABLE_END	
};


enum
{
	LEFT_MOTOR, 
	RIGHT_MOTOR
};

///########################################################################
///
///########################################################################

extern mySemaphore* net_exist_Semaphore;
extern mySemaphore* step_completion_semaphore;
ai::assoc_net_1_with_echolines					*net = NULL;
extern mySemaphore *global_executeSemaphore;

///########################################################################

DWORD WINAPI debug_table_thread_worker(LPVOID UNUSED(threadInfo))
{

#pragma warning(disable : 4127)	
	while (1)
#pragma warning(default : 4127)	
	{
		//global_executeSemaphore->lock();
		net_exist_Semaphore->lock();
		
		if (controller_ptr == NULL)				//lets start controller right now
		{
			//start_controller(); 
			//controller_ptr->init_net(TRUE); 				
		}

		//global_executeSemaphore->unlock();	
		
		
		if (controller_ptr != NULL)				//lets start controller right now
		{		
			controller_ptr->output_innercells_to_console();	
		}
		
		
		net_exist_Semaphore->unlock();
		
		
		Sleep(300);
	}
};

///########################################################################

void __cdecl debug_table_thread_init()
{
	if (net_exist_Semaphore == NULL)
	{
		net_exist_Semaphore = new mySemaphore(1, 1, CREATE, TRUE, "net_exist_semaphore");
		step_completion_semaphore = new mySemaphore(1, 1, CREATE, TRUE, "step_completion_semaphore");
		
		///myThreadArgument* debug_table_thread_Argument = new myThreadArgument(NULL, my_coutSemaphore, my_execSemaphore, &controller_ptr, name3);
		myThread* debug_table_thread = new myThread(debug_table_thread_worker, NULL);						///will wait for new connections
		debug_table_thread->execute();
	}				
};

///########################################################################
/// 
///########################################################################

class BSmartController_Server : public Controller_Server
{
protected:
	
	char																buf[256];
	char																status;
	long																turn_counter;
	long																turn_recovery_counter;	
	int																	step;
	bool																step_complete;
	
	ai::status_vector<ai::assoc_net_1_with_echolines>		my_status_vector;
	
	mutable linked_list::float_a										outputs;
	mutable linked_list::float_a										assigned_outputs;
	
	
	
	
public:
	BSmartController_Server()
	{
		//net = NULL;
		step = -1;
		step_complete = true;
		
		initscreen();
	};
	
	~BSmartController_Server()				//roland: called on reset and program close
	{
		if (win != NULL)
		{
			curses::delwin(win);
			curses::endwin();
		}
		
	
		if (net)
		{	
			net_exist_Semaphore->lock();
			delete net;	
			net = NULL;
			net_exist_Semaphore->unlock();
		}
	};

///########################################################################

protected:

	curses::WINDOW *win;
	int width, height;

	int initscreen() 
	{
		using namespace curses;
		using namespace std;
		
		
		net_exist_Semaphore->lock();
		
	
	
#ifdef XCURSES
		Xinitscr(argc, argv);
#else
		initscr();
#endif
		
#ifdef A_COLOR
		if (has_colors())
			start_color();
#endif

		width  = 170;
		height = 60;

		//win = newwin(height, width, (LINES - height) / 2, (COLS - width) / 2);
		if ((width > COLS) || (height > LINES))
		{
			resize_term(max(height, LINES), max(width, COLS));
		}
		
		
		
		win = newwin(height, width, 0, 0);

		if (win == NULL)
		{
			endwin();
			
			cout << endl << endl << "mingi jama akna loomisega" << endl;
			
			return 1;
		}
		
#ifdef A_COLOR
		if (has_colors())
		{
			init_pair(1, COLOR_WHITE, COLOR_BLUE);
			wbkgd(win, COLOR_PAIR(1));
		}
		else
#endif
			wbkgd(win, A_REVERSE);	
			

		erase();
		//clrtobot();

		werase(win);
		//wclrtobot(win);
		
		//std::ostringstream str;
		//str << "height: " << height << " width: " << width;
		//mvwaddstr(win, 5, 5, str.str().c_str());
		wrefresh(win);
				
		//Continue();
		
		
		
		net_exist_Semaphore->unlock();
		
		
		
		return 0;	
	};
	
///########################################################################
	
	void Continue() const
	{
		using namespace curses;
	
		mvwaddstr(win, 10, 1, " Press any key to continue");
		wrefresh(win);
		raw();
		wgetch(win);
	};
	
///########################################################################
///	
///########################################################################

public:

	void output_innercells_to_console()
	{
		CHART_DATA_STRUCT_A data;
		net->get_innercells(&data);

#if 0
		if ((step <= 10) || ((step % 10) == 0))
		{
			//this->set_charts_data(data, /*size_t line_len = */6 * 3);					
		}
#endif		
		
		this->output_charts_to_console(data, 6 * 3   +   2 * 3);
	
	};

	///########################################################################

protected:

	void set_table_column_data(int charti, int row, int col, float point) const 
	{
		using namespace curses;
		using namespace std;
		
		int x = 5;
		int y = 2;
		int maxlen = 7;
		
		y += charti * 17 + (row - 1) + 1;
		x += (col - 1) * (maxlen + 1) + 1;
		
	
		ostringstream str;
		str << setprecision(maxlen - 3) << point;



		if (point >= 0)
		{
			x++;
			maxlen--;
		}

		mvwaddnstr(win, y, x, str.str().c_str(), maxlen);		
	};
	
	///########################################################################
	
	void set_table_column_str(int charti, int row, int col, std::string str_in) const 
	{
		using namespace curses;
		using namespace std;
		
		int x = 5;
		int y = 2;
		int maxlen = 7;
		
		y += charti * 17 + (row - 1) + 1;
		x += (col - 1) * (maxlen + 1) + 1;
		
	
		ostringstream str;
		str << str_in;


		x++;
		maxlen--;

		mvwaddstr(win, y, x, str.str().c_str()/*, maxlen*/);		
	};
		 
	///########################################################################

	void output_charts_to_console(const CHART_DATA_STRUCT_A &data, int UNUSED(line_len)) const
	{
		using namespace curses;
		using namespace std;
		
		
		
		
		
		
		werase(win);
		
		
		ostringstream str1;
		str1 << "step: " << step;
		if (!step_complete)
			str1 << " in process";
		else
			str1 << " complete";
		mvwaddstr(win, 1, 1, str1.str().c_str());
		
		
		
		
		
		int charti = 0;	
		
		list<CHART_DATA_STRUCT>::const_iterator charts_datas_iter;	
		for(charts_datas_iter = data.charts.begin(); charts_datas_iter != data.charts.end(); charts_datas_iter++)
		{	   	
			const CHART_DATA_STRUCT *chart_data = (const CHART_DATA_STRUCT *)(&*charts_datas_iter);
			
			
			long index[2] = {0, 0};						///a 2D graph needs a 2D array as index array
			//BSTR bstr;
			
			

			index[0] = 1;
			
			list<CHART_LINE_STRUCT>::const_iterator chart_lines_iter;
			for(chart_lines_iter = chart_data->lines.begin(); chart_lines_iter != chart_data->lines.end(); chart_lines_iter++)
			{
				const CHART_LINE_STRUCT *line_data = (const CHART_LINE_STRUCT *)(&*chart_lines_iter);
			
			
				ostringstream str;
				str << index[0] << ". ";
				mvwaddstr(win, charti * 17 + 2 + index[0], 1, str.str().c_str());
			
			
			
				index[1] = 1;
				
				vector<float>::const_iterator line_points_iter;
				for(line_points_iter = line_data->points.begin(); line_points_iter != line_data->points.end(); line_points_iter++)
				{
					if ((index[1] % 3) != 0)
					{
						float point = (float)(*line_points_iter);
											
						
																   
																			
						set_table_column_data(charti, index[0], index[1], point);	
						
						
						
						//if (index[0] == 1)
						//	grid->SetColWidth(index[1], 750);  	   ///750 = 75px
					}
					else
					{					
						//if (index[0] == 1)
						//	grid->SetColWidth(index[1], 150);  	   ///150 = 15px
					}
			
					index[1]++;
				}
				
				
				index[0]++;
			}	
			
			charti++;
		}	
		
		

		
		this->get_net_outputs_for_console();

		
		
		
		step_completion_semaphore->lock();
		
		
		set_table_column_str(3, 0, 1, "outputs (assigned + predicted):");
		
		SFOREACH_I2
		//(
		//	A, DSS, 
			(&outputs)
			{
				float val = *item;	
				
				set_table_column_data(3, 0, (int)index * 3 + 7, val); 				
			}
		//);	
		
		
		set_table_column_str(3, 2, 1, "assigned values:"); 	
		
		SFOREACH_I2
		//(
		//	A, DSS, 
			(&assigned_outputs)
			{
				float val = *item;	
				
				set_table_column_data(3, 2, (int)index * 3 + 7, val); 				
			}
		//);
		
		
		step_completion_semaphore->unlock();
		
/*
	TURN_LEFT,				
	TURN_RIGHT,				
	STRAIGHT,				
	STOP,					
	BACKWARDS_STRAIGHT,		
	WAIT_FOR_START
*/			
		
		
		for (int status_id = STATUS_TABLE_BEGINNING + 1; status_id < STATUS_TABLE_END; status_id++)
		{
			int status_output_id = my_status_vector.get_status_index_const(status_id);
			
			
			std::string status_name;
			switch (status_id)
			{
				case TURN_LEFT:
					status_name = "TURN_LEFT";
					break;
				
				case TURN_RIGHT:
					status_name = "TURN_RIGHT";
					break;

				case STRAIGHT:
					status_name = "STRAIGHT";
					break;
					
				case STOP:
					status_name = "STOP";
					break;
/*
				case BACKWARDS_STRAIGHT:
					status_name = "BACKWARDS_STRAIGHT";
					break;
*/
				case WAIT_FOR_START:
					status_name = "WAIT_FOR_START";
					break;
				
				default:
					status_name = "unknown!";
					break;			
			};
			
			
			if (status_output_id != -1)
			{
				set_table_column_str(3, 4, status_output_id * 3 + 7, status_name);
			}
			else
			{
				IFBREAK;
			}
		}
			
	
		wrefresh(win);
	};
	
	///########################################################################
	
	void get_net_outputs_for_console() const
	{
	
		step_completion_semaphore->lock();
		
		
		if (!step_complete)
		{ 	
			outputs.empty();		
			net->get_outputs(&outputs);					
			
			assigned_outputs.empty();
			net->get_outputs_assigned_values(&assigned_outputs);
		}
		
		
		step_completion_semaphore->unlock();		
	
	};

///########################################################################
///
///########################################################################

public:

	void init_net(bool dontlock = FALSE)
	{
	
		if (!dontlock)
			net_exist_Semaphore->lock();
		
		
		//if (net != NULL)
		//	delete net;
		if (net == NULL)
			net = new ai::assoc_net_1_with_echolines();
		
		
		if (!dontlock)
			net_exist_Semaphore->unlock();
		
		
		 
		 
		net->set_num_inputs(3);
		net->set_num_outputs(6);
		net->set_num_echoline_outputcells(4/*8*/);	
		
	};

	///########################################################################

	void init()
	{	
				
		if (net)
		{	
			net_exist_Semaphore->lock();
			delete net;	
			net = NULL;
			net_exist_Semaphore->unlock();
		}
		
	
	
		status = WAIT_FOR_START;
		turn_counter = 0;	
		turn_recovery_counter = 0;
		step = -1;
		 
		 
#if USE_NET	
	 
		init_net();		 
		
		using ai::sv_cvpair;	 
		 
		my_status_vector.set_net(net);		
		//my_status_vector.enum_statuses(STATUSES);  	 
		my_status_vector.set_status_params_for(TURN_LEFT,			sv_cvpair(LEFT_MOTOR, 0		),	sv_cvpair(RIGHT_MOTOR, -100		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(TURN_RIGHT,			sv_cvpair(LEFT_MOTOR, 100	),	sv_cvpair(RIGHT_MOTOR, 0		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(STRAIGHT,			sv_cvpair(LEFT_MOTOR, 75	),	sv_cvpair(RIGHT_MOTOR, -75		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(STOP,				sv_cvpair(LEFT_MOTOR, 0		),	sv_cvpair(RIGHT_MOTOR, 0		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(WAIT_FOR_START,		sv_cvpair(LEFT_MOTOR, 0		),	sv_cvpair(RIGHT_MOTOR, 0		), sv_cvpair(-1));		
		//my_status_vector.set_status_params_for(BACKWARDS_STRAIGHT,	sv_cvpair(LEFT_MOTOR, -100	),	sv_cvpair(RIGHT_MOTOR, -100		), sv_cvpair(-1));		

#endif	
	 
	};
	
	///########################################################################

	void execute()
	{
		//return;
		using namespace std;
		using namespace curses;
	
		step = getSimulationStep();
		step_complete = false;
		
		
		
		
		sprintf(buf, "--> step nr: %d", step);
		printLn(buf);
																 
		
		int sensorID;					   
        double value;
        bool collision, buttonclick;
        Vector3d position;
        //unsigned char* pixels;
        //long li;
        
        double left_distance, middle_distance, right_distance;
        
        
        enable_printLn();
        disable_printLn();
        
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.L1.distance");			//leftmost
        getSensorValue(sensorID, value);		
		sprintf(buf, "L1: %f", value);
		printLn(buf);
		left_distance = value;
		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.L2.distance");			//center
        getSensorValue(sensorID, value);		
		sprintf(buf, "L2: %f", value);
		printLn(buf);
		middle_distance = value;		
		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.L3.distance");			//rightmost
        getSensorValue(sensorID, value);		
		sprintf(buf, "L3: %f", value);
		printLn(buf);
		right_distance = value;		

		
		
		
		
		
		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.button1.click");			//button
        getSensorValue(sensorID, buttonclick);		
		sprintf(buf, "Button1: %s", buttonclick ? "click" : "free");
		printLn(buf);		
		
		
		
		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.GPS.position");
        getSensorValue(sensorID, position);        	
		sprintf(buf, "GPS: x(%f) y(%f) z(%f)", position.v[0], position.v[1], position.v[2]);
		printLn(buf);		
		
		
		
		
		
		
		
        sensorID = getSensorportId("B-Smart.robot1.bumper_left.collision");			//left
        getSensorValue(sensorID, collision);		
		sprintf(buf, "Bumper left: %s", collision ? "collision" : "free");
		printLn(buf);
		
        sensorID = getSensorportId("B-Smart.robot1.bumper_right.collision");			//right
        getSensorValue(sensorID, collision);		
		sprintf(buf, "Bumper right: %s", collision ? "collision" : "free");
		printLn(buf);		

		
		
#if 0		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.cam1.image");			//center, BGR format, no padding
        getSensorValue(sensorID, pixels);		
        li = 0;
		sprintf(buf, "Pixels1: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
		printLn(buf);
		li = 9;		
		sprintf(buf, "Pixels2: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
		printLn(buf);		
		li = 18;		
		sprintf(buf, "Pixels3: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
		printLn(buf);	
		delete pixels;			//NB!	
#endif
		
		
		
		
		disable_printLn();
		
		
		
		
		
		
		
		enable_printLn();
		
		
		
		bool ignore_turn = false;
		
		
		if (step < 2)
		{
			status = WAIT_FOR_START;
			goto e_control_calc;
		}	
		else if ((left_distance < 0.1) && (right_distance < 0.1) && (middle_distance < 0.1))
		{
			status = STOP;
			goto e_control_calc;
		}	
		else if ((left_distance < 0.8) && (right_distance < 0.8) && (middle_distance < 0.8) && (middle_distance > 0.5))
		{
			ignore_turn = true;
		}
		
		
		if ((left_distance < 0.5) && (abs(left_distance - middle_distance) > 0.2) && !ignore_turn || (left_distance < 0.3))
		{
			status = TURN_LEFT;
			turn_counter = 10;
		}							  
		else if ((right_distance < 0.5) && (abs(right_distance - middle_distance) > 0.2) && !ignore_turn || (right_distance < 0.3))
		{
			status = TURN_RIGHT;
			turn_counter = 10;
		}
		else if (middle_distance < 0.5)
		{
		
			if (middle_distance < 0.1)
			{
				if (turn_recovery_counter < 0)
				{
					status = TURN_RIGHT;	
				}
				else if (turn_recovery_counter > 0)
				{
					status = TURN_LEFT;	
				}
				else 
				{			
					turn_counter = 0;
					
					status = STRAIGHT;
				}
			}
			else
			{	
				if (turn_counter > 0)
				{
					turn_counter -= 2;  
				}
				
				if (turn_counter <= 0)
				{			  			
					status = STRAIGHT;				
				}
			}
		}
		else
		{
			if (turn_counter > 0)
			{
				turn_counter--;
			}
			
			
			if (turn_counter <= 0)
			{			  			
				status = STRAIGHT;				
			}
		}
		
		
e_control_calc:		
		
		
#if USE_NET	&& 1	
/*

	NET:		
	- set_inputs
	- set_outputs
	- tick_echo_lines					//move data from input cells to first echoline cells, as input cells should not have assoc_lines anymore
	- calc_predictions
	- get_outputs
	- update_corrs
	- prepare_for_next_cycle
	
*/							

	///##################################################################  		


		linked_list::float_a values_in;	
		values_in.set_num_items(3);
		values_in.set_item_atindex(0, TA(left_distance));	
		values_in.set_item_atindex(1, TA(middle_distance));	
		values_in.set_item_atindex(2, TA(right_distance));	
		net->set_inputs(values_in);
		
#if 0		
		float_a values_out;
		values_out.set_num_items(6);
		values_out.set_item_atindex(0, TA((status == TURN_RIGHT) ? 1 : 0));	
		values_out.set_item_atindex(1, TA((status == TURN_LEFT) ? 1 : 0));				
		values_out.set_item_atindex(2, TA((status == STRAIGHT) ? 1 : 0));	
		values_out.set_item_atindex(3, TA((status == BACKWARDS_STRAIGHT) ? 1 : 0));				
		values_out.set_item_atindex(4, TA((status == STOP) ? 1 : 0));	
		values_out.set_item_atindex(5, TA((status == WAIT_FOR_START) ? 1 : 0));				
		net->set_outputs(values_out);
#else
		my_status_vector.reset_status_values();
		my_status_vector.activate_status(status);
#endif		
		
		
		net->tick_echo_lines();
		net->calc_predictions();
		
		
		
	///##################################################################  		
	///	
	///##################################################################  		
		
		
		linked_list::float_a values_out2;			  
		net->get_outputs(&values_out2);
		
		
		
		disable_printLn();
		
		sprintf(buf, "net status predictions:");
		sprintf(buf, "%s\r\nTURN_LEFT = %f",				buf, my_status_vector.get_status_val(TURN_LEFT));
		sprintf(buf, "%s\r\nTURN_RIGHT = %f",				buf, my_status_vector.get_status_val(TURN_RIGHT));
		sprintf(buf, "%s\r\nSTRAIGHT = %f",				buf, my_status_vector.get_status_val(STRAIGHT));
		sprintf(buf, "%s\r\nSTOP = %f",					buf, my_status_vector.get_status_val(STOP));
		//sprintf(buf, "%s\r\nBACKWARDS_STRAIGHT = %f",		buf, my_status_vector.get_status_val(BACKWARDS_STRAIGHT));
		sprintf(buf, "%s\r\nWAIT_FOR_START = %f",			buf, my_status_vector.get_status_val(WAIT_FOR_START));
		printLn(buf);	
		
		
		
		
#if 1		
		
#if 0		
		const CHART_DATA_STRUCT_A &datas = data;
		std::ostringstream os;
		boost::archive::binary_oarchive oa(os);
		oa << datas;
		//oa << line_len;
		//oa << auto_set_num_charts;	
		
		string str = os.str(); 
#endif		
				
#else
		//save_innercells_data(data);
		
		const CHART_DATA_STRUCT_A &data_out = data;	
		std::ofstream ofs("net_assoc_lines.dat");
		boost::archive::binary_oarchive oa(ofs);
		oa << data_out;
		
#endif		
			
		

	///##################################################################  		
		

		linked_list::float_a param_vals;
		my_status_vector.get_blended_status_params(&param_vals, LEFT_MOTOR, RIGHT_MOTOR, -1);
		
		A leftmotor_speed;
		A rightmotor_speed;
		ai::flist(&leftmotor_speed, &rightmotor_speed, NULL) = param_vals;
		
		sprintf(buf, "net predictions: L(%f) R(%f)", leftmotor_speed, rightmotor_speed);
		printLn(buf);		
		

	///##################################################################
	///
	///##################################################################  		
		
		this->get_net_outputs_for_console();
		
		
		net->update_corrs();
		net->prepare_for_next_cycle();
		
		

	///##################################################################  		
		
		
#endif		//#if USE_NET			
		
		
		
		
		disable_printLn();
		
		sprintf(buf, "turn_counter, turn_recovery_counter: %d : %d", turn_counter, turn_recovery_counter);
		printLn(buf);
		
		
		
		int leftmotor = getActuatorportId("B-Smart.robot1.wheel1.motorVelocity");
		int rightmotor = getActuatorportId("B-Smart.robot1.wheel3.motorVelocity");
		if (status == TURN_RIGHT)
		{
			setActuatorport(leftmotor, 100); 
			setActuatorport(rightmotor, 0);
			
			turn_recovery_counter++;
			
			
			printLn("TURN_RIGHT");			
		}
		else if (status == TURN_LEFT)
		{
			setActuatorport(leftmotor, 0);
			setActuatorport(rightmotor, -100);	
			
			turn_recovery_counter--;
			
			
			printLn("TURN_LEFT");			
		}		
		else if (status == STRAIGHT)
		{
			setActuatorport(leftmotor, 75);
			setActuatorport(rightmotor, -75);
												    
			printLn("STRAIGHT");
		}
		else
		{
			setActuatorport(leftmotor, 0);
			setActuatorport(rightmotor, 0);		
			
			printLn("MOTORS OFF");
		}		
		
		
		
		printLn("");
		
#if 0		
		if((step > 20) && (step < 1000))
		{
			int id = getActuatorportId("B-Smart.robot1.wheel1.motorVelocity");
			setActuatorport(id, 90);
			//id = getActuatorportId("B-smart.robot1.wheel2.motorVelocity");
			//setActuatorport(id, 0.02);
			id = getActuatorportId("B-Smart.robot1.wheel3.motorVelocity");
			setActuatorport(id, -90);
		}
		else
		{
			int id = getActuatorportId("B-Smart.robot1.wheel1.motorVelocity");
			setActuatorport(id, 0.0);
			//id = getActuatorportId("B-smart.robot1.wheel2.motorVelocity");
			//setActuatorport(id, 0.02);
			id = getActuatorportId("B-Smart.robot1.wheel3.motorVelocity");
			setActuatorport(id, 0.0);		
		}
#endif		
    
    
    
		step_complete = true;
    
	};
};

//CONNECT_CONTROLLER_TO_SCENE(BSmartController, "B-Smart");

#if 0

void __cdecl start_controller() 
{
	controller_ptr = new BSmartController_Server();
} 

#else

/*
#define CONNECT_CONTROLLER_TO_SCENE2(server_controller_class, scene_name, init_func)	\
																						\
void start_controller()																	\
{																						\
	controller_ptr = new server_controller_class();										\
}																						\
																						\
extern void (__cdecl *initapp_func)();														    \
extern void (__cdecl *start_func)();														    \
																						\
																						\
																						\
initapp_func = &init_func;																\
start_func = &start_controller;															\
*/

//CONNECT_CONTROLLER_TO_SCENE2(BSmartController_Server, "B-Smart", debug_table_thread_init);


void __cdecl start_controller()																	
{																						
	controller_ptr = new BSmartController_Server();										
}																						

void __cdecl server_main();
																						
extern void (__cdecl *initapp_func)();														    
extern void (__cdecl *start_func)();														    
																						
/*extern Controller_manager Controller_manager_obj;	*/									
																						
/*Controller_manager::set_start_func(start_controller);*/							    
/*Controller_manager::set_initapp_func(init_func);*/								    

void __cdecl main()
{
																						
	initapp_func = debug_table_thread_init;																
	start_func = start_controller;															
	
	server_main();
}


#endif

/*
void __cdecl main() {												

	server_main(debug_table_thread_init, start_controller); 												 
												 
}
*/												 
												 
#endif //#ifndef BSMART_SERVER_H												 