/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



//#line 3 "joonejalgija.h"				///compiler seems to have trouble following this include inside a function otherwise



			
			
	#if 1	
			unsigned int datapoints = 0;	
			sensorID = getSensorportId("tasandid_scene.robot1.cam1.image");			//center, BGR format, no padding
			getSensorValue(sensorID, pixels, &datapoints);	
			/*	
			li = 0;
			sprintf(buf, "Pixels1: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
			printLn(buf);
			li = 15 * 3;		
			sprintf(buf, "Pixels2: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
			printLn(buf);		
			li = 30 * 3;		
			sprintf(buf, "Pixels3: %d %d %d %d %d %d %d %d %d", pixels[0 + li], pixels[1 + li], pixels[2 + li], pixels[3 + li], pixels[4 + li], pixels[5 + li], pixels[6 + li], pixels[7 + li], pixels[8 + li]);	//BGR format
			printLn(buf);
			*/	
	#endif
		
		
		
		
	#define SEND_CAMERA_IMAGE_TO_NET 0
		
			
	#if SEND_CAMERA_IMAGE_TO_NET		
			datapoints = datapoints / 3;
			
			net->set_num_inputs(NUM_NET_BASE_INPUTS + datapoints);	
			net->set_num_echoline_outputcells(num_echoline_outputcells, 0);			//NB! we must set this again!
			net->set_num_echoline_outputcells(num_echoline_outputcells2, 1);
			
				
			values_in.set_num_items(NUM_NET_BASE_INPUTS + datapoints);
			SFOREACH2
			//(
			//	linked_list::float_a, 
				(&values_in)
				{
					*item = 0;
				}	
			//);
	#else
			//values_in.set_num_items(NUM_NET_BASE_INPUTS);		
	#endif







	#if 0
			static bool secondcycle = false;
			
			
			
			
			//memcpy(pixels2.pixels, pixels, datapoints * 3);
			pixels2.setpixels(pixels);
			pixels2.width = 15;
			pixels2.height = 5;



			//if (pixels2_old.pixels != NULL)
			if (secondcycle)
			{
				werase(win);
			
				BRG_PIXEL<S> diff = levenshtein(pixels2, pixels2_old, win);


				ostringstream str;
				str << "R: " << (int)diff.r << "   G: " << (int)diff.g << "   B: " << (int)diff.b << "   ";	
				mvwaddstr(win, 2, 2, str.str().c_str());
				wrefresh(win);

				
				
			}
			
			pixels2_old = pixels2;
			secondcycle = true;
			

			delete pixels;
			return;
	#endif






	
	
	static statuses laststatus = STOP; 		
	
	static float emergency_turnpercentage = 2.5;
	static int line_lost_emergency_cycles = 200;
	
	static int line_lost_cycles = 0;
	
	
	
	
	const int max_rows = 5;
	//const int max_cols = 15;
	
	float left_signal = 0;
	float middle_signal = 0;
	float right_signal = 0;
	float joone_kalle = 0;
	static float last_joone_kalle = 0;
	bool joon_leitud = false;
	bool all_rows_found = true;
	
	static float prev_sum_for_row[max_rows];
	
	
	
//#if !USE_OPERANT_NET						
	if (/*1 && */(step < 10))
	{
		FOR (i, max_rows)
			prev_sum_for_row[i] = 0;	
		
	
		status = WAIT_FOR_START;
		///delete pixels;
		goto e_control_calc;
	}
	else
//#endif		
	{  			
		
		leia_joone_kalle(pixels, prev_sum_for_row, joone_kalle, joon_leitud, all_rows_found);
		
		
		
		
		
		///max kalle = +/- 21
		
#if !USE_OPERANT_NET			
		joone_kalle = maxf(joone_kalle, -21);
		joone_kalle = minf(joone_kalle, 21);
#endif
		
		
		if (joone_kalle < 0)		///joon on vasakul, seega ka robot peab prama vasakule
		{
			status = TURN_LEFT;
			turnpercentage = -joone_kalle / 21 + (float)0.25;
			
			laststatus = status;
			
			
			left_signal = turnpercentage;//-joone_kalle / 21;	
			
			
			line_lost_cycles = 0;
		}
		else if (joone_kalle > 0)		///joon on paremal, seega ka robot peab prama paremale
		{
			status = TURN_RIGHT;
			turnpercentage = joone_kalle / 21 + (float)0.25;
			
			laststatus = status;
			
			
			right_signal = turnpercentage;//joone_kalle / 21;
			
			
			line_lost_cycles = 0;
		}	
		else if (joone_kalle == 0)
		{
			if (joon_leitud)
			{
				if (status != STRAIGHT)
				{
					//manual_control = true;			//lets teach the robot to drive straight too!
				}
			
			
				status = STRAIGHT;
				turnpercentage = 0;
				
				middle_signal = 1;
				
				
				
				
				
									
				
				line_lost_cycles = 0;
			}
			else
			{
				//status = WAIT_FOR_START;
				status = laststatus;
				turnpercentage = 1.5;
				joone_kalle = last_joone_kalle;
				
				
				line_lost_cycles++;
				
				
				if (line_lost_cycles >= line_lost_emergency_cycles)
				{					
					///emergency = true;
				}
			}
		}
		
		last_joone_kalle = joone_kalle;
		
		
		
		if (turnpercentage > emergency_turnpercentage)
		{
			///emergency = true;
		}
		

	}
	
	
	suppress_learning = !all_rows_found;
	
	
	
	
	
	
//#if !USE_OPERANT_NET								
e_control_calc:	
//#endif





	if (lastkeypress != -1)
	{
		//bool emergency_old = emergency;
		//emergency = true;
		manual_control = true;
		
		/*
		left_signal = 0;
		middle_signal = 0;
		right_signal = 0;
		*/
		
		switch(lastkeypress)
		{
			case 1:
				status = TURN_LEFT;
				turnpercentage = 1.5;
				//left_signal = turnpercentage;
				break;
				
				
			case 4:
				status = TURN_LEFT;
				turnpercentage = 0.75;
				//left_signal = turnpercentage;
				break;


			case 7:
				status = TURN_LEFT;
				turnpercentage = 0.25;
				//left_signal = turnpercentage;
				break;


			case 8:
				status = STRAIGHT;
				turnpercentage = 0;
				//middle_signal = 1;
				break;


			case 9:
				status = TURN_RIGHT;
				turnpercentage = 0.25;
				//right_signal = turnpercentage;
				break;


			case 6:
				status = TURN_RIGHT;
				turnpercentage = 0.75;
				//right_signal = turnpercentage;
				break;


			case 3:
				status = TURN_RIGHT;
				turnpercentage = 1.5;
				//right_signal = turnpercentage;
				break;
		
		
			default:
				//emergency = emergency_old;
				manual_control = false;				   //we dont need to recover signal variables because net will not learn nor robot will move
				break;			
		}		
	
	
		lastkeypress = -1;
	}
	
	





	
	
//#if USE_NET	&& 1	
///##################################################################  		

	
	values_in.set_item_atindex(0, TA(joone_kalle));
	
	values_in.set_item_atindex(1, TA(left_signal));	
	values_in.set_item_atindex(2, TA(middle_signal));	
	values_in.set_item_atindex(3, TA(right_signal));	
	
	//net->set_inputs(values_in);



	//values_in.set_item_atindex(1, TA(0));	
	//values_in.set_item_atindex(2, TA(0));	




	operant_actual_value = joone_kalle;



