/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



///########################################################################

protected:




	void mybeep()
	{
	/*
		Beep(
		  1000,	///DWORD dwFreq,
		  200	///DWORD dwDuration	in ms
		);	
	*/
	
		do_beep = true;
	
	};





	
	int width, height;
	
	
	

	int initscreen() 
	{
		using namespace curses;
		using namespace std;
	
	
#ifdef XCURSES
		Xinitscr(argc, argv);
#else
		initscr();
#endif
		
#ifdef A_COLOR
		if (has_colors())
			start_color();
#endif

		int width1, height1;
		
		width1	= width  = 319;	//512;	//319;
		height1 = height = 127;
		
		int const COL_WIDTH_CONST = 33;
		int const LEFTMARGIN_WIDTH_CONST = 7;
#if !USE_OPERANT_NET		
		int const TOPBOTTOM_MARGIN_HEIGHT_CONST = 3 + (14 - 4);
#else
		int const TOPBOTTOM_MARGIN_HEIGHT_CONST = 3 + (16 - 4);
#endif		
		
		
		int cols = 1;
		int rows = 1;
			

		//win = newwin(height, width, (LINES - height) / 2, (COLS - width) / 2);
		if ((width > COLS) || (height > LINES))
		{
			int res;
			
			
			height	= max(height1, LINES);
			width	= max(width1, COLS);
				
			res = resize_term(height, width);		///lets try max resolution at first
			
			
			if (!((res == OK) && (LINES >= height) && (COLS >= width)))
			{
			
				//height	= max(height1 - (MAX_NUM_DISPLAY_CHARTS_CONST - rows) * CHART_HEIGHT, LINES);
				//width	= max(width1 - (MAX_NUM_DISPLAY_COLS_CONST - cols) * 30, COLS);
				height	= max(rows * CHART_HEIGHT + TOPBOTTOM_MARGIN_HEIGHT_CONST, LINES);
				width	= max(cols * COL_WIDTH_CONST + LEFTMARGIN_WIDTH_CONST, COLS);
									
				res = resize_term(height, width);
				
				if ((res == OK) && (LINES >= height) && (COLS >= width))
				{
					do
					{
						if (cols == MAX_NUM_DISPLAY_COLS_CONST)
							break;
							
						cols++;
							
							
						height	= max(rows * CHART_HEIGHT + TOPBOTTOM_MARGIN_HEIGHT_CONST, LINES);
						width	= max(cols * COL_WIDTH_CONST + LEFTMARGIN_WIDTH_CONST, COLS);
						
						res = resize_term(height, width);
					} 
					while ((res == OK) && (LINES >= height) && (COLS >= width));
					
					cols--;
					
					
					
					do
					{
						if (rows == MAX_NUM_DISPLAY_CHARTS_CONST)
							break;
							
						rows++;
						
						
						height	= max(rows * CHART_HEIGHT + TOPBOTTOM_MARGIN_HEIGHT_CONST, LINES);
						width	= max(cols * COL_WIDTH_CONST + LEFTMARGIN_WIDTH_CONST, COLS);
						
						res = resize_term(height, width);
					} 
					while ((res == OK) && (LINES >= height) && (COLS >= width));
					
					rows--;
					
					
					
					height	= max(rows * CHART_HEIGHT + TOPBOTTOM_MARGIN_HEIGHT_CONST, LINES);
					width	= max(cols * COL_WIDTH_CONST + LEFTMARGIN_WIDTH_CONST, COLS);
					
					resize_term(height, width);
					
					
					
					MAX_NUM_DISPLAY_CHARTS	= rows;
					MAX_NUM_DISPLAY_COLS	= cols;
				}
				else
				{
					endwin();
				
					cout << endl << endl << "ei nnestunud luua minimaalse suurusega akent" << endl;
					
					return 1;
				}
			}
			else
			{
				MAX_NUM_DISPLAY_CHARTS	= MAX_NUM_DISPLAY_CHARTS_CONST;
				MAX_NUM_DISPLAY_COLS	= MAX_NUM_DISPLAY_COLS_CONST;
			}
			
		}
		else
		{
			MAX_NUM_DISPLAY_CHARTS	= MAX_NUM_DISPLAY_CHARTS_CONST;
			MAX_NUM_DISPLAY_COLS	= MAX_NUM_DISPLAY_COLS_CONST;
		}
		
		
		win = newwin(height, width, 0, 0/*, true*/);

		if (win == NULL)
		{
			endwin();
			
			cout << endl << endl << "mingi jama akna loomisega" << endl;
			
			return 1;
		}
		
#ifdef A_COLOR
		if (has_colors())
		{
			init_pair(1, COLOR_BRIGHTWHITE, COLOR_BLACK);
			init_pair(2, COLOR_BRIGHTYELLOW, COLOR_BLACK);			
			init_pair(3, COLOR_BRIGHTCYAN, COLOR_BLACK);			

			init_pair(5, COLOR_BRIGHTWHITE, COLOR_BLUE);
			init_pair(6, COLOR_BRIGHTYELLOW, COLOR_BLUE);			
			init_pair(7, COLOR_BRIGHTCYAN, COLOR_BLUE);			


			wbkgd(win, COLOR_PAIR(1));
		}
		else
#endif
			wbkgd(win, A_REVERSE);	
			

		erase();
		//clrtobot();

		werase(win);
		//wclrtobot(win);
		
		//std::ostringstream str;
		//str << "height: " << height << " width: " << width;
		//mvwaddstr(win, 5, 5, str.str().c_str());
		wrefresh(win);
				
		//Continue();
		
		return 0;	
	};
	
///########################################################################
	
	void Continue() const
	{
		using namespace curses;
	
		mvwaddstr(win, 10, 1, " Press any key to continue");
		wrefresh(win);
		raw();
		wgetch(win);
	};
	
///########################################################################
///	
///########################################################################


public:

	void output_classified_innercells_to_console() const 
	{
	
		///inputs
		output_classified_innercells_to_console__worker(10, inputs_echoline_classified_innercells);
		
		
		///outputs
		output_classified_innercells_to_console__worker(20, outputs_echoline_classified_innercells);
			
	
	};
	
	///########################################################################
	
	void output_classified_innercells_to_console__worker(int xpos, CLASSIFIED_ECHOLINE_INNERCELLS_COLLECTION C &collection)   const
	{
		const int srow = 11;
		const int charti = 0;
		
	
		for 
		(
			CLASSIFIED_ECHOLINE_INNERCELLS_COLLECTION::array_type::const_iterator iter = collection.class_echoes_collection.begin(); 
			iter != collection.class_echoes_collection.end(); 
			iter++
		)
		{
			//CLASSIFIED_ECHOLINE_INNERCELLS C *innercells = (CLASSIFIED_ECHOLINE_INNERCELLS C *)(&*iter);	
			CLASSIFIED_ECHOLINE_INNERCELLS C &innercells = *iter;	
			
			int row = srow;
			for 
			(
				CLASSIFIED_ECHOLINE_INNERCELLS::array_type::const_iterator iter2 = innercells.class_echoes.begin();
				iter2 != innercells.class_echoes.end();
				iter2++	
			)
			{
				S C &val = *iter2;
			
				set_table_column_data2(charti, row, 0, val, xpos, 0);	
				
				row += 2;
			}
		}
	
	};

	///########################################################################
	///
	///########################################################################

	virtual void output_innercells_to_console(int *x_scroll, int *y_scroll) //const
	{
		static int x_scroll_prev = INT_MIN;
		static int y_scroll_prev = INT_MIN;
		
	
	
		if (!steps_occured && (x_scroll_prev == *x_scroll) && (y_scroll_prev == *y_scroll))
		{
			return;
		}
		else
		{
			steps_occured = false;		//lets reset it in the beginning so that if net is updated during screen update, then screen update happens later once more
		}
		
	
	
	
		if (!enable_screen)
			return;
	
	
	
		x_scroll_prev = *x_scroll;
		y_scroll_prev = *y_scroll;
		
	
	
	
	
		//DEBUG_SEMAPHORE_LOCK;
		CHART_DATA_STRUCT_A &data = chart_data_struct__in_obj;
		
		data.max_line_i_in_chart				= max_line_i_in_chart;		///!
		data.max_assoc_point_i_in_assoc_cell	= MAX_NONLINEAR_ASSOC_CELL_POINTS_TO_SHOW;
		net->get_innercells(&data, NUM_NET_BASE_INPUTS);
		
		//DEBUG_SEMAPHORE_UNLOCK;

#if 0
		if ((step <= 10) || ((step % 10) == 0))
		{
			//this->set_charts_data(data, /*size_t line_len = */6 * 3);					
		}
#endif		
		
		this->output_charts_to_console(data, 6 * 3   +   2 * 3, x_scroll, y_scroll);
	
		
		
	
	};

	///########################################################################

protected:

	void set_table_column_data(int charti, int row, int col1, IN cell_value C &point_cv) const 
	{
		CHART_DATA_POINT cdp_val;
		cdp_val.val = point_cv;

		set_table_column_data(charti, row, col1, cdp_val);	
	};

	///########################################################################
	
	void set_table_column_data(int charti, int row, int col1, IN CHART_DATA_POINT C &point_cv, IN B show_always = false) const 
	{
		using namespace curses;
		using namespace ai;
	
		bool active			= point_cv.active;
	    bool just_created	= point_cv.just_created;
	    
	    
	    
	    if (col1 > MAX_NUM_DISPLAY_COLS)
			return;
	    
	    
	    
	    
	    int col = col1 * 3;
	    
	
#if 1	
		static int num_active_cells;
		//static std::vector<CHART_DATA_POINT> history(16);
		if (point_cv.index == 0)
		{
			num_active_cells = 0;
			
			chart_data_point_history.clear();				
			chart_data_point_history.resize(16);				   //TODO: resize makes get_innercells slow
		}
		
		if (point_cv.index != (size_t)-1)
			chart_data_point_history[point_cv.index] = point_cv;
		
	
	
		if (active)
		{
			num_active_cells++;
			
			if (num_active_cells > 2)
			{
				BREAK;
			}
		}

#endif

		cell_value point1 = point_cv.corr_point.input_value;
		cell_value point2 = point_cv.corr_point.output_value;
	
	
		//if (!active && !just_created && (point_cv.get_samples() == 0))
			//return;
	
#if 0	
		bool singledata = false;
		if (!point1.hassamples() && !point2.hassamples())
		{
			point1 = point_cv.val;	
			singledata = true;
		}
#endif		
		
		
		
#if USE_OPERANT_NET
		int xp = col * 1;
		xp -= /*abs(col1 - 1) / 3 * 27 +*/ 20;		
#else			
		int xp = col * 1;
		//xp -= abs(col1 - 1) / 3 * 25 + 20;
		xp -= 20;
#endif		
		
		
		
		int bkg_color_shift = 0;
		if ((((row - 1) / 4) & 1) == 1)
		{
			bkg_color_shift = 4;
		}
		



		if (active)
		{
			wbkgdset(win, COLOR_PAIR(2 + bkg_color_shift));		///YELLOW
		}
		else if(just_created)
		{
			wbkgdset(win, COLOR_PAIR(3 + bkg_color_shift));		///CYAN
		}
		else if (bkg_color_shift)
		{
			wbkgdset(win, COLOR_PAIR(1 + bkg_color_shift));		///WHITE
		}
		
		
		if (/*singledata*/ !point_cv.corr_point_set)
		{
			point1 = point_cv.val;
			if (show_always || point1.hassamples())
			{
				set_table_column_data2(charti, row * 2, col, point1.EX(), xp);
				set_table_column_data2(charti, row * 2, col + 1, point1.n(), xp);
				if (show_always || (point1.n() > 0))
					set_table_column_data2(charti, row * 2, col + 2, point1.q(), xp);
			}
		}
		else
		{	
			if (show_always || active || just_created || point1.hassamples() || point2.hassamples() || point_cv.corr_point_set)
			{
				set_table_column_data2(charti, row * 2, col, point1.EX(), xp);
				set_table_column_data2(charti, row * 2, col + 1, point1.n(), xp);
				
				//if (show_always || (point1.n() > 0))
					set_table_column_data2(charti, row * 2, col + 2, point1.q(), xp);
			//}

			//if (active || just_created || point2.hassamples())
			//{
				set_table_column_data2(charti, row * 2 + 1, col, point2.EX(), xp);
				set_table_column_data2(charti, row * 2 + 1, col + 1, point2.n(), xp);
				
				//if (show_always || (point2.n() > 0))
					set_table_column_data2(charti, row * 2 + 1, col + 2, point2.q(), xp);
			}
		}

		//if (active || just_created)
		{
			wbkgdset(win, COLOR_PAIR(1));
		}


	};
	
	///########################################################################

	void set_table_column_data2(int charti, int row, int col, float point, int xp = 0, int precision = 3) const 
	{
		using namespace curses;
		using namespace std;
		
		int x = 5;
		int y = 2;
		int maxlen = 9;
		
		y += charti * CHART_HEIGHT + (row - 1) + 3;
		x += (col - 1) * (maxlen + 1) + 1 + xp;
		
	
#if 0	
		ostringstream str;
		str.precision(maxlen - 6);
		//if (!(point < 0))	///detect -0 too
		//	str << " ";
			
			
		bool oldsync = std::ios_base::sync_with_stdio(false);					   ///The static member function stores a stdio sync flag, which is initially true. When true, this flag ensures that operations on the same file are properly synchronized between the iostreams functions and those defined in the Standard C++ Library. Otherwise, synchronization may or may not be guaranteed, but performance may be improved. The function stores _Sync in the stdio sync flag and returns its previous stored value. You can call it reliably only before performing any operations on the standard streams.
		
		if (!(point < 0))	///detect -0 too
			str << " " /*<< setprecision(maxlen - 6)*/ << point << "                            ";
		else
			str /*<< setprecision(maxlen - 6)*/ << point << "                            ";
			
		//std::ios_base::sync_with_stdio(oldsync);



		if (!(point < 0))	///detect -0 too
		{
			//x++;
			//maxlen--;
		}

		mvwaddnstr(win, y, x, str.str().c_str(), maxlen + 2);
#else 
	#if 0
		char *buffer;  
		int decimal, sign; 
		
		/*
		if (!(point < 0))		///detect -0 too
			mvwaddnstr(win, y, x, "                            ", maxlen + 2);
		else
			mvwaddnstr(win, y, x, "-                           ", maxlen + 2);
		
		buffer = _fcvt(point, maxlen - 6, &decimal, &sign);
		mvwaddnstr(win, y, x + 1, buffer, decimal);
		mvwaddnstr(win, y, x + 1 + decimal, ".", 1);
		//if (maxlen + 2 - decimal - 1 > 0)
		//	mvwaddnstr(win, y, x + 1 + decimal + 1, &buffer[decimal], maxlen + 2 - decimal - 1);
		mvwaddstr(win, y, x + 1 + decimal + 1, &buffer[decimal]);
		*/
		
		//int index;
		
		/*
		if (!(point < 0))		///detect -0 too
			mvwaddnstr(win, y, x, "                            ", maxlen + 2);
		else
			mvwaddnstr(win, y, x, "-                           ", maxlen + 2);
		*/
		
		
		//char (&cbuf2)[256] = cbuf;
		
		
		
		int index;
		if (!(point < 0))	  ///detect -0 too
		{
			index = 1;
			//cbuf2[0] = '-';
			strcpy(cbuf, "                             ");
		}
		else
		{
			index = 1;
			strcpy(cbuf, "-                            ");
		}
		
		
		if ((point > -1) && (point < 1))  
		{				
			cbuf[index] = '0';
			index++;
		}
		
			
		buffer = _fcvt(point, maxlen - 6, &decimal, &sign);		///If count is less than or equal to the length of strSource, a null character is not appended automatically to the copied string.
		
		strncpy(&cbuf[index], buffer, decimal);
		cbuf[index + decimal] = '.';
		strcpy(&cbuf[index + decimal + 1], &buffer[decimal]);
		
		mvwaddnstr(win, y, x, cbuf, maxlen + 2);
		
		
		
		
		/*
		if (!(point < 0))	///detect -0 too
		{
			buffer = _fcvt(point, maxlen - 6, &decimal, &sign);
			mvwaddnstr(win, y, x + 1, buffer, maxlen + 2);
		}
		else
		{
		    buffer = _fcvt(point, maxlen - 6, &decimal, &sign);
		    mvwaddnstr(win, y, x, buffer, maxlen + 2);
		}
		*/
		
		

	#else
		
	
		#if 1
		
			if (precision == 0)
			{
				if (!(point < 0))	///detect -0 too
					sprintf(cbuf, " %.0f                            ", point);
				else
					sprintf(cbuf, "%.0f                            ", point);
			}  
			else if (precision == 1)
			{
				if (!(point < 0))	///detect -0 too
					sprintf(cbuf, " %.1f                            ", point);
				else
					sprintf(cbuf, "%.1f                            ", point);
			}		
			else if (precision == 3)
			{
				if (!(point < 0))	///detect -0 too
					sprintf(cbuf, " %.3g                            ", point);
				else
					sprintf(cbuf, "%.3g                            ", point);
			}
			else if (precision == 6)
			{
				if (!(point < 0))	///detect -0 too
					sprintf(cbuf, " %-08.6f                            ", point);
				else
					sprintf(cbuf, "%-08.6f                            ", point);
			}
			else if (precision == 7)
			{
				if (!(point < 0))	///detect -0 too
					sprintf(cbuf, " %-09.7f                            ", point);
				else
					sprintf(cbuf, "%-09.7f                            ", point);
			}
			else
			{
				MYASSERT(false);
			}
			
			mvwaddnstr(win, y, x, cbuf, maxlen + 2);
			
		#else
		
			//char *str = fcvt(point, 3, 
		
		
		#endif
		
		
	#endif
#endif				
	};
	
	///########################################################################
	
	void set_table_column_str(int charti, int row, int col1, std::string str_in) const 
	{
		using namespace curses;
		using namespace std;
		
		
		
		
		if (col1 > MAX_NUM_DISPLAY_COLS)
			return;
		
		
		int x = 5;
		int y = 2;
		int maxlen = 9;

		
		
		int col = col1 * 3;
		
		int xp = col * 1;
		xp -= 20;
		
		
		y += charti * CHART_HEIGHT + (row - 1) + 3;
		x += (col - 1) * (maxlen + 1) + 1 + xp;
		
		

		//x -= abs(col1 - 1) / 3 * 27 + 20;
		
		
	
		ostringstream str;
		str << str_in << "                            ";


		x++;
		maxlen--;

		mvwaddstr(win, y, x, str.str().c_str()/*, maxlen*/);		
	};
		 
	///########################################################################

	void chart_energy_levels(bool chart_oldvars = false) C
	{
		const int xp = chart_oldvars ? 10 : 31;
		//const int charti = 1;
		const int precision = 6;
		const int srow = 11;
		//const int charti = 0;


		FORI(i, chart_oldvars ? 1 : 0, (S)inputoutputs_energy_levels.inputoutputs_collection.size())
		{
			INSIGHTFUL_INPUTOUTPUT_ENERGY_LEVELS C &inputs_data = inputoutputs_energy_levels.inputoutputs_collection[i];
			
			//S col = i * 3;
			S col = 0;
			S charti = i;
			
			FOR(j, (S)inputs_data.energy_levels.size())
			{
				INSIGHTFUL_INPUTOUTPUT_ENERGY_LEVEL C &level_data = inputs_data.energy_levels[j];
			
				A value			= level_data.value;
				A total_energy	= level_data.total_energy; 
				
				
				S row = srow + j * 1;
				
				set_table_column_data2(charti, row, col + 0, value,			xp, precision);
				set_table_column_data2(charti, row, col + 1, total_energy,	xp, precision);
			}
		}
	
	};

	///########################################################################

	void chart_futurelines(size_t index, int position, int charti = 1) C
	{
		const int xp = 57;
		//const int charti = 1;
		const int precision = 6;
		const int srow = 10;	   
		const int max_io_cols = 2;
	
	
		size_t num_operants = operants2.operants.size();
		num_operants = minuS(max_io_cols, num_operants);
				
		
		FOR(operant_i, (ssize_t)num_operants)
		{
			OPERANTS_CHART_DATA_STRUCT C &curr_operant = operants2.operants[operant_i];
			size_t num_alternative_futurelines = curr_operant.alternative_futurelines.size();
			
			
			int col = operant_i * 4;
			col += (num_operants * 4 + 1) * position;
			
			
			size_t alternative_futureline_i = index;
			
			//FOR(alternative_futureline_i, (ssize_t)num_alternative_futurelines)
			if (alternative_futureline_i < num_alternative_futurelines)
			{
				ALTERNATIVE_FUTURELINE_ITEMS_CHART_DATA_STRUCT C &curr_alternative_futureline = curr_operant.alternative_futurelines[alternative_futureline_i];
				size_t curr_futureline_len = curr_alternative_futureline.futureline.size();
				
				//A anticipated_val_sum = 0;
				//A energy_sum = 0;
				
				FOR(futureline_item_i, (ssize_t)curr_futureline_len)
				{
					FUTURELINE_ITEMS_CHART_DATA_STRUCT C &curr_futureline_point = curr_alternative_futureline.futureline[futureline_item_i];
				
					A planned_actions_anticipated_value_diff_factor	= curr_futureline_point.planned_actions_anticipated_value_diff_factor.mean();
					A anticipated_diff								= curr_futureline_point.anticipated_value_diff.mean();
					A anticipated_val								= curr_futureline_point.anticipated_value.mean();
					A energy										= curr_futureline_point.energy;
				
					int row;
					if (futureline_item_i > 0)
						row = srow + curr_futureline_len - futureline_item_i;
					else
						row = srow + curr_futureline_len + 3;
				
					set_table_column_data2(charti, row, col + 0, planned_actions_anticipated_value_diff_factor,			xp, precision);
					set_table_column_data2(charti, row, col + 1, anticipated_diff,										xp, precision);
					set_table_column_data2(charti, row, col + 2, anticipated_val,										xp, precision);	
					set_table_column_data2(charti, row, col + 3, energy,												xp, precision);
					
					
					/*if ((futureline_item_i > 0) && (anticipated_diff > 0) && (alternative_futureline_i == 1))
					{
						IFBREAK;
					}  */
					
					//anticipated_val_sum += anticipated_val;
					//energy_sum += energy;
				}
				
				/*
				FUTURELINE_ITEMS_CHART_DATA_STRUCT C &curr_futureline_point = curr_alternative_futureline.futureline[0];
				
				A anticipated_val	= curr_futureline_point.anticipated_value.mean();
				A energy			= curr_futureline_point.energy;
					
				set_table_column_data2(charti, curr_futureline_len + 3, col, anticipated_val_sum, xp, precision);
				set_table_column_data2(charti, curr_futureline_len + 3, col + 1, energy_sum, xp, precision);	
				*/
				
				//set_table_column_data2(charti, curr_futureline_len + 3, col, anticipated_val_sum, xp, precision);
				//set_table_column_data2(charti, curr_futureline_len + 3, col + 1, energy_sum, xp, precision);	
					
				//col += (num_operants * 2 + 2);
			}
		}
	};

	///########################################################################

	void output_charts_to_console(const CHART_DATA_STRUCT_A &data, int UNUSED(line_len), int *x_scroll_in = NULL, int *y_scroll_in = NULL) const
	{
		using namespace curses;
		using namespace std;
		
#if 0		
		if (!steps_occured)
		{
			return;
		}
		else
		{
			steps_occured = false;		//lets reset it in the beginning so that if net is updated during screen update, then screen update happens later once more
		}
#endif		
		
		
		
		int x_scroll = 0;
		int y_scroll = 0;
		
		if (x_scroll_in != NULL)
		{
			if (*x_scroll_in < 0)
				*x_scroll_in = 0;
		
			x_scroll = *x_scroll_in; 		
		}
			
		if (y_scroll_in != NULL)
		{
			if (*y_scroll_in < 0)
				*y_scroll_in = 0;
				
			y_scroll = *y_scroll_in;					
		}
		
		
		
		
		
		//werase(win);
		
		
		
		
		
		ostringstream str1;
		str1 << "step: " << step;
		if (!step_complete)
			str1 << " in process";
		else
			str1 << " complete";
		mvwaddstr(win, 1, 1, str1.str().c_str());
		
		



		ostringstream str2;
		str2 << "mode: ";
		str2 << ((mode == MODE_LEARN) ? "MODE_LEARN" : "MODE_PREDICT");
		mvwaddstr(win, 1, 30, str2.str().c_str());
		
		
		
		
		
		
		ostringstream str3; 
				
		if (status == BUTTONCLICK_PAUSE__NET_LOADED)
			str3 << "NET LOADED";			
		else if (status == BUTTONCLICK_PAUSE__NET_SAVED)
			str3 << "NET SAVED";
		else if (status == BUTTONCLICK_PAUSE)
			str3 << "MODE SWITCHING";
		
		mvwaddstr(win, 1, 50, str3.str().c_str());
		
		
		
		///return;
		
		

		
		
		
		
		
		
		
		int charti = 0;	
		
		//list<CHART_DATA_STRUCT>::const_iterator charts_datas_iter;	
		vector<CHART_DATA_STRUCT>::const_iterator charts_datas_iter;	
		for(charts_datas_iter = data.charts.begin(); charts_datas_iter != data.charts.end(); charts_datas_iter++)
		{	
			if ((charti - y_scroll) >= 0)
			{
				ostringstream strR;				
		   		strR << "R " << charti << "   ";
				mvwaddstr(win, (charti - y_scroll) * CHART_HEIGHT + 3, 1, strR.str().c_str());		 ///row nr
				//set_table_column_str(charti - y_scroll, -2, 1, strR.str());
							
							
							
				const CHART_DATA_STRUCT *chart_data = (const CHART_DATA_STRUCT *)(&*charts_datas_iter);
				
				
				long index[2] = {0, 0};						///a 2D graph needs a 2D array as index array
				//BSTR bstr;
				
				

				index[0] = 1;
				
				//list<CHART_LINE_STRUCT>::const_iterator chart_lines_iter;
				vector<CHART_LINE_STRUCT>::const_iterator chart_lines_iter;
				for(chart_lines_iter = chart_data->lines.begin(); chart_lines_iter != chart_data->lines.end(); chart_lines_iter++)
				{
					const CHART_LINE_STRUCT *line_data = (const CHART_LINE_STRUCT *)(&*chart_lines_iter);
				
				
					ostringstream str;
					str << index[0] << ".   ";
					mvwaddstr(win, (charti - y_scroll) * CHART_HEIGHT + 4 + index[0] * 2, 1, str.str().c_str());
				
				
				
					index[1] = 1;	 ///col
					
					//vector<std::list<CHART_DATA_POINT>>::const_iterator line_points_iter;
					vector<std::vector<CHART_DATA_POINT> >::const_iterator line_points_iter;
					for(line_points_iter = line_data->points.begin(); line_points_iter != line_data->points.end(); line_points_iter++)
					{
						/*if ( 
							1 
							|| (index[1] <= 3) 
							|| ((index[1] % 3) != 1) 
						)*/
						{
#if 0						
							if ((charti - y_scroll) == 0)
							{
								
								int col1 = index[1];
								
						#if USE_OPERANT_NET		
								ostringstream strI;
								ostringstream strO;
						
								int col_inner = col1 - 4;
								col_inner -= x_scroll;
								
								if (col_inner < 1)
									goto nextcol_labels;
									
								col1 = col_inner + 4;
						#else 		
								ostringstream strC;
							
								int col_inner = col1 - 2;
								col_inner -= x_scroll;
								
								if (col_inner < 1)
									goto nextcol_labels;
									
								col1 = col_inner + 2; 			
						#endif

								
						
						#if USE_OPERANT_NET
								if (!(index[1] & 1))
								{
									strI << "I " << (index[1] / 2) << "   ";
									set_table_column_str(1, -2, col1 * 3 + 6, strI.str());
								}
								else
								{
									strO << "O " << (index[1] / 2) << "   ";
									set_table_column_str(1, -2, col1 * 3 + 6, strO.str());
								}
						#else		
								strC << "C " << index[1] << "   ";
								//mvwaddstr(win, 1 * CHART_HEIGHT + 4, col1, str.str().c_str());	 ///column nr
								set_table_column_str(1, -2, col1 * 3 + 6, strC.str());
						#endif		
								
								nextcol_labels:;
							}
#endif						
						
							
							
						
						
						
							//const std::list<CHART_DATA_POINT> *points = (const std::list<CHART_DATA_POINT> *)(&*line_points_iter);
							const std::vector<CHART_DATA_POINT> *points = (const std::vector<CHART_DATA_POINT> *)(&*line_points_iter);
						
							
																	   
							//std::list<CHART_DATA_POINT>::const_iterator corr_points_iter = points->begin();
							std::vector<CHART_DATA_POINT>::const_iterator corr_points_iter = points->begin();
							for (int corr_point_i = 0; corr_point_i < MAX_NONLINEAR_ASSOC_CELL_POINTS_TO_SHOW; corr_point_i++)
							{
								if (corr_point_i < (int)points->size())
								{
									const CHART_DATA_POINT *point = (const CHART_DATA_POINT *)(&*corr_points_iter);
									
									long line_i;
									bool show_always;
									if (index[1] <= 4)
									{
										if (index[1] <= 2)
											line_i = index[0];		 ///row
										else
											line_i = (index[0] - 1) * 4 + 1;
											
										show_always = true;
									}
									else
									{
										line_i = (index[0] - 1) * MAX_NONLINEAR_ASSOC_CELL_POINTS_TO_SHOW + corr_point_i + 1;
										
										show_always = false;
									}
																		
									if (line_i <= max_line_i_in_chart)
									{
										int col1 = index[1];	
										
								#if USE_OPERANT_NET
										if (col1 > 4)
											col1 -= 1;		///skip this col
										//if (col1 >= 5)
										//	col -= 3;		///skip this col	
								#else		
										col1 = (col1 + 1) / 3 + 1;
								#endif		
										
								
										///int col1a = col1;
								
										int col_inner = col1 - fixedcols;
										if (col1 > fixedcols)
										{
											col_inner -= x_scroll;
											
											if (col_inner < 1)
												goto nextcol;
												
											col1 = col_inner + fixedcols;
										}
								
								
										//int col = col1 * 3;
																	
										set_table_column_data(charti - y_scroll, line_i, col1, *point, show_always);		
										
										
										
										if (
											//((charti - y_scroll) == 0)
											//&&
											(index[0] == 1)					   ///first row
											&&
											(col1 > fixedcols)
										)
										{
											
										
										#if 0
											strC << "C " << (col_inner + x_scroll - 1) << "   ";
											//mvwaddstr(win, 1 * CHART_HEIGHT + 4, col1, str.str().c_str());	 ///column nr
											set_table_column_str(0, -1, col1, strC.str());	
										#endif
											
											
											int cindex = (col_inner + x_scroll - 1);
											
									#if USE_OPERANT_NET
											
											if (!(cindex & 1))
											{
												ostringstream strI;
												strI << "I " << (cindex / 2) << "   ";
												set_table_column_str(0, -1, col1, strI.str());
											}
											else
											{
												ostringstream strO;
												strO << "O " << (cindex / 2) << "   ";
												set_table_column_str(0, -1, col1, strO.str());
											}
									#else		
											ostringstream strC;
											strC << "C " << cindex << "   ";
											set_table_column_str(0, -1, col1, strC.str());	
									#endif		
																
										}
									}
									
							
									
							nextcol:								
							
									corr_points_iter++;	
									
								}													
							}
							
							
							
							//if (index[0] == 1)
							//	grid->SetColWidth(index[1], 750);  	   ///750 = 75px
						}
						/*else
						{					
							//if (index[0] == 1)
							//	grid->SetColWidth(index[1], 150);  	   ///150 = 15px
						}  */
				
						index[1]++;
					}
					
					
					index[0]++;
					
					if (index[0] == (max_line_i_in_chart + 1))
						break;
				}	
			}	///if ((charti - y_scroll) >= 0)
			
			
			charti++;
			
			if ((charti - y_scroll) == MAX_NUM_DISPLAY_CHARTS)
				break;
		}
		
		
		
			
		
		

		DEBUG_SEMAPHORE_LOCK;
		this->get_net_inputsoutputs_for_console();
		DEBUG_SEMAPHORE_UNLOCK;
		
		
		
		step_completion_semaphore->lock();
		
#if 0	
	
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 0 - 2, 1, "outputs (assigned + predicted):");
		
		SFOREACH_I2(&outputs)
		{
			cell_value val = *item;	
			
			set_table_column_data(3, 0, (int)index * 3 + 5, val); 				
		}
			
#else



#if USE_OPERANT_NET	

		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 2 - 2, 1, "preferred value:");	  
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 4 - 2, 1, "actual value:");
			  
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 6 - 2, 1, "discrepancy:");
		//set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 8 - 2, 1, "discrepancy diff:");
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 8 - 2, 1, "actual value diff:");
		
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 10 - 2, 1, "anticipated discrepancy diff:");
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 12 - 2, 1, "unanticipated discrepancy diff:");

#else

		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 2 - 2, 1, "assigned value | predicted value:");	  
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 4 - 2, 1, "assigned value:");
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 6 - 2, 1, "predicted value:");
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 8 - 2, 1, "unpredicted value:");

#endif


		int output_index = 0;
		
#if !USE_OPERANT_NET	
	
		//std::list<OUTPUTS_CHART_DATA_STRUCT>::const_iterator outputs_iter;
		std::vector<OUTPUTS_CHART_DATA_STRUCT>::const_iterator outputs_iter;
		for(outputs_iter = outputs2.outputs.begin(); outputs_iter != outputs2.outputs.end(); outputs_iter++)		
		{	
		
			OUTPUTS_CHART_DATA_STRUCT *mystruct = (OUTPUTS_CHART_DATA_STRUCT *)(&*outputs_iter);
			
#else

		//std::list<OPERANTS_CHART_DATA_STRUCT>::const_iterator operants_iter;
		std::vector<OPERANTS_CHART_DATA_STRUCT>::const_iterator operants_iter;
		for(operants_iter = operants2.operants.begin(); operants_iter != operants2.operants.end(); operants_iter++)		
		{	
		
			OPERANTS_CHART_DATA_STRUCT *mystruct = (OPERANTS_CHART_DATA_STRUCT *)(&*operants_iter);
			
#endif			
			
			
			
			
			int col1 = (int)output_index/* * 3*/ + 3 - 2 + fixedcols;
			
			
			
			///int col1a = col1;
	
			int col_inner = col1 - fixedcols;
			if (col1 > fixedcols)
			{
				col_inner -= x_scroll;
				
				if (col_inner < 1)
					goto nextcol_ovals;
					
				col1 = col_inner + fixedcols;
			}
			
			
			
#if USE_OPERANT_NET	

			cell_value preferred_value				= mystruct->preferred_value;
			cell_value actual_value					= mystruct->actual_value;
			
			cell_value discrepancy					= mystruct->discrepancy;
			//cell_value discrepancy_diff				= mystruct->discrepancy_diff;
			cell_value value_diff					= mystruct->value_diff;
			
			cell_value anticipated_discrepancy_diff	= mystruct->anticipated_discrepancy_diff;
			cell_value unpredicted_discrepancy_diff	= mystruct->unpredicted_discrepancy_diff;
			
			
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 1 - 1, col1, preferred_value);				
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 2 - 1, col1, actual_value);
			
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 3 - 1, col1, discrepancy);	
			//set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 4 - 1, col1, discrepancy_diff);
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 4 - 1, col1, value_diff);
			
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 5 - 1, col1, anticipated_discrepancy_diff);
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 6 - 1, col1, unpredicted_discrepancy_diff);	
			
#else		 

			cell_value value						= mystruct->value;
			cell_value assigned_value				= mystruct->assigned_value;
			cell_value predicted_value				= mystruct->predicted_value;
			cell_value unpredicted_value			= mystruct->unpredicted_value;

			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 1 - 1, col1, value);
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 2 - 1, col1, assigned_value);
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 3 - 1, col1, predicted_value);
			set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 4 - 1, col1, unpredicted_value);	
			
#endif			

			
		nextcol_ovals:
			
			output_index++;
		}



		charti = 0;
		//std::list<INPUTS_CHART_DATA_STRUCT>::const_iterator inputs_iter;
		std::vector<INPUTS_CHART_DATA_STRUCT>::const_iterator inputs_iter;
		for(inputs_iter = inputs2.inputs.begin(); inputs_iter != inputs2.inputs.end(); inputs_iter++)
		{	

			INPUTS_CHART_DATA_STRUCT *mystruct = (INPUTS_CHART_DATA_STRUCT *)(&*inputs_iter);			

			cell_value input_value = mystruct->value;
			
			if (!(
				((charti - y_scroll) < 0)
				|| 
				((charti - y_scroll) == MAX_NUM_DISPLAY_CHARTS)
			))
			{		
				
					
					
				set_table_column_data(charti - y_scroll, 0, 1, input_value);					   ///input value
			}
			
			
			charti++;
			
		}



	#if USE_OPERANT_NET
	
		charti = 0;
		//std::list<OUTPUTS_CHART_DATA_STRUCT>::const_iterator outputs_iter;
		std::vector<OUTPUTS_CHART_DATA_STRUCT>::const_iterator outputs_iter;
		for(outputs_iter = outputs2.outputs.begin(); outputs_iter != outputs2.outputs.end(); outputs_iter++)
		{	

			OUTPUTS_CHART_DATA_STRUCT *mystruct = (OUTPUTS_CHART_DATA_STRUCT *)(&*outputs_iter);			

			cell_value output_value = mystruct->value;
			
			if (!(
				((charti - y_scroll) < 0)
				|| 
				((charti - y_scroll) == MAX_NUM_DISPLAY_CHARTS)
			))
			{		
				
					
					
				set_table_column_data(charti - y_scroll, 0, 2, output_value);					   ///output value
			}
			
			
			charti++;
			
		}
		
	#endif		




#endif	
	
		
		
#if 0		
		
		set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 10 - 2, 1, "assigned values:"); 	

	#if 0		
		SFOREACH_I2
		//(
		//	A, DSS, 
			(&assigned_outputs)
			{
				cell_value val = *item;	
				
				set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 8, (int)index * 3 + 6, val); 				
			}
		//);
	#else


		///for (S i = 0; i < 

		//segmented_linked_list_customsize_iterator<cell_value, DSS, FALSE> iter;	
		io_vals_a_T::my_iterator_T iter;
		iter.set_list(&assigned_outputs);									
		bool at_end = iter.at_end();						
		cell_value *item;										
		S index = 0;										
														
		while(!at_end)										
		{													
			item = iter.get_currdata();						
			{
				cell_value val = *item;	
				
				
				
				///ostringstream str;
				
				
				int col1 = (int)index/* * 3*/ + 3;
				
				///int col1a = col1;
		
				int col_inner = col1 - fixedcols;
				if (col1 > fixedcols)
				{
					col_inner -= x_scroll;
					
					if (col_inner < 1)
						goto nextcol_vals;
						
					col1 = col_inner + fixedcols;
				}
				
				
				
				set_table_column_data(MAX_NUM_DISPLAY_CHARTS, 5 - 1, col1, val); 		///output value
				
								
				
				
				
			nextcol_vals:;
			
			}											
			iter.next();									
			at_end = iter.at_end_notempty();				
			index++;										
		};													
	#endif	
	
#endif			
		
		
		step_completion_semaphore->unlock();
		
/*
	TURN_LEFT,				
	TURN_RIGHT,				
	STRAIGHT,				
	STOP,					
	BACKWARDS_STRAIGHT,		
	WAIT_FOR_START
*/			
		
		
#if !USE_OPERANT_NET		
		for (int status_id = STATUS_TABLE_BEGINNING + 1; status_id < STATUS_TABLE_END; status_id++)
		{
			int status_output_id = my_status_vector.get_status_index_const(status_id);
			
			
			std::string status_name;
			switch (status_id)
			{
				case TURN_LEFT:
					status_name = "TURN_LEFT";
					break;
				
				case TURN_RIGHT:
					status_name = "TURN_RIGHT";
					break;

				case STRAIGHT:
					status_name = "STRAIGHT";
					break;
					
				case STOP:
					status_name = "STOP";
					break;
/*
				case BACKWARDS_STRAIGHT:
					status_name = "BACKWARDS_STRAIGHT";
					break;
*/
				case WAIT_FOR_START:
					status_name = "WAIT_FOR_START";
					break;
				
				default:
					status_name = "unknown!";
					break;			
			};
			
			
			if (status_output_id != -1)
			{
			
				int col1 = status_output_id * 1 + 3 - 2 + fixedcols;
			
			
		#if USE_OPERANT_NET		
				int col_inner = col1 - 4;
				col_inner -= x_scroll;
				
				if (col_inner < 1)
					goto nextcol_statuses;
					
				col1 = col_inner + 4;
		#else 			
				int col_inner = col1 - 2;
				col_inner -= x_scroll;
				
				if (col_inner < 1)
					goto nextcol_statuses;
					
				col1 = col_inner + 2; 			
		#endif
			
			
			
				set_table_column_str(MAX_NUM_DISPLAY_CHARTS, 12 - 2 - 2, col1, status_name);
				
				
				
				
				
				
			nextcol_statuses:;
			
			}
			else
			{
				///IFBREAK;
			}
		}
#endif		
			
	
		wrefresh(win);
	};
	
	///########################################################################
	
	void get_net_inputsoutputs_for_console(bool dont_output_futurelines = false) const
	{
		if (!enable_screen)
			return;
			
			
		DEBUG_SEMAPHORE_LOCK;	
		step_completion_semaphore->lock();
		
		
		
		if (!step_complete)
		{ 	
		
			net->get_outputs_classified_innercells(outputs_echoline_classified_innercells);
			net->get_inputs_classified_innercells(inputs_echoline_classified_innercells);
		

		
		
		
			//outputs.empty();		
			net->get_outputs(&outputs);					
			
			//assigned_outputs.empty();
			net->get_outputs_assigned_values(&assigned_outputs);
						
						
						
			m_log << assigned_outputs.get_item_atindex(0)->mean() << "\t" << assigned_outputs.get_item_atindex(1)->mean() << "\t" << assigned_outputs.get_item_atindex(2)->mean() << "\t";
			m_log << endl;
						
						
																				
			
#if USE_OPERANT_NET

			//if (!dont_output_futurelines)
			//	chart_futurelines(0, 0);			///move prev val to left
				

			//operants2.operants.clear();
			net->get_operants(&operants2);
#endif												
			
			//outputs2.outputs.clear();
			net->get_outputs(&outputs2);
			
			//inputs2.inputs.clear();
			net->get_inputs(&inputs2, NUM_NET_BASE_INPUTS);				
		}				
		
					
								
		DEBUG_SEMAPHORE_UNLOCK;		
		step_completion_semaphore->unlock();		
	
	};

