/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################





#include "tasandid_server_stdafx.h"
//#include "tasandid_stdafx.h"

																

//#undef NET_DECLARE_ONLY			//NB!


///#######################################################################
///
///#######################################################################


//#include "../clientserver/server/tasandid_server_stdafx.h"



#define GNUPLOT_DECLARE_ONLY
#include "gnuplot/gnuplot_i.h"





#include "tasand1/config.h"




#undef NET_DECLARE_ONLY






#include "datastructures/chart_datastructures.h"					//chart data structures

#include "../clientserver/server/myServer.h"









#define NET_DECLARE_ONLY

																			   

//#define NET_DECLARE_ONLY
//namespace tasandid
//{
//};




///#include "../clientserver/server/stdafx.h"


///#include "Controller.h"
///namespace tasandid
///{


///#pragma comment(lib, "tasandid4_18_combined_project.lib") 


///#define __TASAND_1_CPP__				//for cvop class instantiation etc
///#define DEFINITIONS_CPP
///#define DEBUG_SEMAPHORE_CPP

///};

///#include "Controller3DDrawing.h"
///#include <Platform/OpenGL.h>


///#include "Win32Application/MSchartDemo/stdafx.h"
///#include "Win32Application/MSchartDemo/TDS_chart.h"







#ifndef BSMART_SERVER_H
#define BSMART_SERVER_H




#define USE_BLENDED_STATUS_VECTOR 0
static int num_echoline_outputcells = 30;		//4;		//8;		//8;
static int num_echoline_outputcells2 = 6;
bool enable_screen = true;
///definitions::enable_break_global = true;






#define NET_DECLARE_ONLY

#include "debug_semaphore.h"
#include "tasand1_operant_net/operant_net.h"
//#include "tasand3_comb_cells/comb_cells2.h"								   ///its good idea to include this as last include, because it defines mutiple shortcut definitions that might conflict with other headers otherwise
#include "tasand2/pattern_cell.h"											   ///class PIXEL_A
#include "tasand1_echo_lines/echo_lines.h"								   ///its good idea to include this as last include, because it defines mutiple shortcut definitions that might conflict with other headers otherwise
///#include "tasand1/cell_value.h"


#ifndef USE_OPERANT_NET													    

	#if _DEBUG
		#define USE_OPERANT_NET 1			  
	#else
		#define USE_OPERANT_NET 1
	#endif
#endif




#include "combined_project\net_select.h"


							   

#if !USE_OPERANT_NET


	//typedef ai::assoc_net_1_with_echolines_and_nonlinear_assoc_cells						tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_echolines_and_modular_assoc_cells						tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_echolines_and_divided_som_cells							tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_echolines_and_divided_som_cells2							tasandid_server_net_type;
	typedef ai::assoc_net_1_with_timewarping_echolines_and_divided_som_cells2				tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_timelines_classical										tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_timelines_classical2										tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_timelines_classical3										tasandid_server_net_type;
	//typedef ai::assoc_net_1_with_timelines_classical4										tasandid_server_net_type;

	//typedef ai::assoc_net_1_with_echolines_and_nonlinear_assoc_cells_and_comb_cells		tasandid_server_net_type;



	#define USE_DISCRIMINANT_NET						0
	#define TEST_LINEFOLLOWER							1
	#define ACTION_STRENGTH_MEANS_ACTION_DURATION		0
	


	#pragma message ("using classical net")


#else

	typedef ACTIVE_NET																			tasandid_server_net_type;


	//typedef ai::simple_operant_net_1_with_echolines											tasandid_server_net_type;
	//typedef ai::timewarping_simple_operant_net_1_with_echolines								tasandid_server_net_type;
	//typedef ai::simple_operant_net_1_with_echolines2											tasandid_server_net_type;
	//typedef ai::timewarping_operant_net_12													tasandid_server_net_type;
	//typedef ai::discriminant_operant_net3														tasandid_server_net_type;
	//typedef ai::insightful_operant_net5															tasandid_server_net_type;
	//typedef ai::insightful_operant_net6														tasandid_server_net_type;
	//typedef ai::simple_discriminant_operant_net_1_with_echolines								tasandid_server_net_type;
	
	

	#include "test_config.h"



	#pragma message ("using operant net")


#endif





bool output_classified_innercells						= false;




#if !USE_DISCRIMINANT_NET
	#define NUM_NET_BASE_INPUTS								4
	#define NUM_NET_BASE_OUTPUTS							6
	#define NUM_NET_OPERANTS								1
#else

	#if TEST_INTERVAL_SCHEDULE
		#define NUM_NET_BASE_INPUTS								3		//3		//3		//2
	#else
		#define NUM_NET_BASE_INPUTS								3		//3		//3		//2	
	#endif
	
	
	#define NUM_NET_BASE_OUTPUTS							NUM_OUTPUTS			//SELECT(1, 1, 3)
	#define NUM_NET_OPERANTS								1
#endif	

	
#define MAX_NUM_DISPLAY_CHARTS_CONST					3
#define MAX_NUM_DISPLAY_COLS_CONST						8
#define CHART_HEIGHT									36
#define MAX_NONLINEAR_ASSOC_CELL_POINTS_TO_SHOW			4






#define DEFAULT_FOREGROUND_COLOR				COLOR_WHITE

#if 0
#define COLOR_BLACK			0
#define COLOR_BLUE			1
#define COLOR_GREEN			2
#define COLOR_CYAN			3
#define COLOR_RED			4
#define COLOR_MAGENTA		5
#define COLOR_YELLOW		6
#define COLOR_WHITE			7
#endif

#define COLOR_GRAY			8
#define COLOR_BRIGHTBLUE	9
#define COLOR_BIRGHTGREEN	10
#define COLOR_BRIGHTCYAN	11
#define COLOR_BRIGHTRED		12
#define COLOR_BRIGHTMAGENA	13
#define COLOR_BRIGHTYELLOW	14
#define COLOR_BRIGHTWHITE	15 






#include "datastructures/status_vector.h"


#include "tasandid_server.h"




#pragma warning (disable : 4533 4702)




using namespace ai;



int simulationstep;
int start_simulationstep = -1;
int	&step = simulationstep;





///########################################################################
///
///########################################################################

class duration_measurer
{

public:

	duration_measurer()
	{
		this->init();	
	};
	
	V init() 
	{
		measure = 0;
	};

	V reset() 
	{
		this->init();
	};

	A tick(B yesno)
	{
		if (yesno)
			measure += reciprocal(duration_one_timesteps_quota);
		else
			measure = 0;
			
		measure = minmaxf(measure, 0.0f, 1.0f);
		
		return measure;
	};

	A tick(A val_in = 1.0f)
	{
		measure += (val_in * 2 - 1) / duration_one_timesteps_quota;
		
		measure = minmaxf(measure, 0.0f, 1.0f);
		
		return measure;
	};
	
	A get() C 
	{
		return measure;
	};


protected:

	A measure;

};

///########################################################################
///
///########################################################################


template <typename T, S delay>
class input_data_delayer_struct
{

	static const S buf_len		= 256;
	
	BOOST_STATIC_ASSERT(delay >= 0);
	

public:

	input_data_delayer_struct()
	{
		MYASSERT(buf_len > delay);
	
		pointer = 0;
		buf.init();
	};

	~input_data_delayer_struct()
	{
		buf.deinit();
	};

	void set(S index, typename T::elem_T C &val)
	{
		buf[pointer].reset();
		buf[pointer][index] = val;
		pointer++;
		
		if (pointer == (S)buf_len)
			pointer = 0;
	};
		
	void set(T C &val)
	{
		buf[pointer] = val;
		pointer++;
		
		if (pointer == (S)buf_len)
			pointer = 0;
	};
	
	T C& get() const
	{
		S outpointer = pointer - delay - 1;			/// -1 : we assume that before each get() we call set()
		if (outpointer < 0)
			outpointer += buf_len;
			
		MYASSERT(outpointer >= 0);
		
		return buf[outpointer];
	};
	
	
	
protected:	
	
	T_A<buf_len, T>			buf;
	S						pointer;		

};


///########################################################################
///
///########################################################################


class status_pair : public void_class_with_copy_constructor
{
public:

	static const bool call_init_deinit = true;


public:

	status_pair()
	{
		init();
	};
	
	/*status_pair(A val_in)
	{
		status = -1;
		val = val_in;
	};*/
	
	status_pair(statuses status_in, A val_in)
	{
		status = status_in;
		val = val_in;
	};

	void init()
	{
		status = STRAIGHT;
		val = 0;
	};	  	
	void deinit() {};
	void reset() { init(); };

public:
	statuses	status;
	A			val;

};


///########################################################################
///
///########################################################################


std::vector<ai::CHART_DATA_POINT>									chart_data_point_history(16);	///we need to put it here, or static lists memory will not be freed on object destruction


///########################################################################
/// 
///########################################################################

///########################################################################
/// 
///########################################################################

template 
< 
	typename io_vals_a_T = linked_list::sllc<ai::cell_value>
>
class TasandidController_Server_base : public Controller_Server
{
private:

	typedef TasandidController_Server_base											my_T;
	typedef type_array::AA<BOOST_PP_MAX(NUM_NET_BASE_INPUTS, 8)>					input_values_a_T;
	typedef type_array::AA<BOOST_PP_MAX(NUM_NET_BASE_INPUTS, 4)>					operant_values_a_T;
	typedef type_array::T_A<BOOST_PP_MAX(NUM_NET_BASE_INPUTS, 4), status_pair>		output_values_a_T;


protected:
	
	char																buf[256];
	
	statuses															status;
	statuses															buttonclick_laststatus;
	
	long																turn_counter;
	long																turn_recovery_counter;	
	//int																	step;
	bool																step_complete;
	
	ai::status_vector<tasandid_server_net_type>							my_status_vector;
	bool																action_complete;
	
	mutable io_vals_a_T													outputs;
	mutable io_vals_a_T													assigned_outputs;
	
	mutable OPERANTS_CHART_DATA_STRUCT_A								operants2;
	mutable OUTPUTS_CHART_DATA_STRUCT_A									outputs2;
	mutable INPUTS_CHART_DATA_STRUCT_A									inputs2;
	
	mutable INSIGHTFUL_INPUTOUTPUTS_ENERGY_LEVELS						inputoutputs_energy_levels;
	
	mutable CLASSIFIED_ECHOLINE_INNERCELLS_COLLECTION					outputs_echoline_classified_innercells;
	mutable CLASSIFIED_ECHOLINE_INNERCELLS_COLLECTION					inputs_echoline_classified_innercells;
	
	
	mutable bool														steps_occured;
	
	modes																mode;
	modes																prevmode;
	int																	buttonclick_pause_counter;
	
	int																	lastkeypress;
	
	ai::PIXEL_A<unsigned char, 15, 5>									pixels2_old;				   ///we need to put it here, or static lists memory will not be freed on object destruction
	
	CHART_DATA_STRUCT_A													chart_data_struct__in_obj;				///lets make it constantly allocated, this way we prevent excessive resize calls during get_innercell methods
	
	
	
	input_data_delayer_struct<input_values_a_T, delay_input_data_timesteps>				input_data_delayer;
	input_data_delayer_struct<output_values_a_T, delay_output_data_timesteps>			output_data_delayer;
	input_data_delayer_struct<operant_values_a_T, delay_operant_data_timesteps>			operant_data_delayer;
	
	
	duration_measurer													interval_measure;
	
	
	
	A operant_preferred_value;	//cell_value(0);
	A operant_actual_value;	//cell_value(0);
	A operant_actual_value__prev;
	
	float turnpercentage;
	
	A turnpercentagec1;
	A turnpercentagec2;

	A discriminant1;
	A discriminant2;
	A discriminant3;
	
	
	
	
	myLog																testseries_logger;
	A																	action_counter1;
	A																	action_counter2;
	bool																reinforcement_is_scheduled;
	bool																ratio_tick_is_scheduled;
	S																	ratio_ticks;

	
	
///########################################################################
///
///########################################################################


#include "tasandid_screenfuncs.h"	


///########################################################################
///
///########################################################################


#include "tasandid_initfuncs.h"


///########################################################################
///
///########################################################################


private:
	
	void button_reaction()
	{
		status = BUTTONCLICK_PAUSE;
		buttonclick_pause_counter = 10;
	};
	
	///########################################################################

	template <typename status_vector_T>
	A activate_status(status_vector_T &status_vector, statuses status, A val, bool readonly = false) const
	{
		MYASSERT(readonly);
		
		return const_cast<my_T *>(this)->activate_status(status_vector, status, val, true);
	};
	
	template <typename status_vector_T>
	A activate_status(status_vector_T &status_vector, statuses status, A val, bool readonly = false)
	{
		A rval;	// = 0;
	
		IFC((NUM_NET_BASE_OUTPUTS == 1) && !ACTION_STRENGTH_MEANS_ACTION_DURATION)
		{
			MYASSERT(!readonly);
			
		
			if (status == TURN_LEFT)
			{
				//status_vector.activate_status(0, -val);
				rval = -(val * 0.75 + 0.25);
				//status_vector.net->set_output_atindex(0, );	
			}
			else if (status == TURN_RIGHT)
			{
				//status_vector.activate_status(0, val);
				rval = val * 0.75 + 0.25;
				//status_vector.net->set_output_atindex(0, val * 0.75 + 0.25);	
			}
			else
			{
				//status_vector.activate_status(0, 0);
				rval = 0;
				//status_vector.net->set_output_atindex(0, 0);	
			}
			
			//status_vector.net->set_output_atindex(0, rval);
			
			status_pair new_status_pair(status, rval);
			output_data_delayer.set(0, new_status_pair);			
			status_vector.net->set_output_atindex(0, output_data_delayer.get()[0].val);
			
			//status_vector.net->outputs_tick_echolines_first_cell();
			status_vector.net->tick_echolines_first_cell();					///must tick all echolines because during manual control s.a is suppressed and inputs too are yet unticked
		}
		else
		{
			if (!readonly)
			{
				status_pair new_status_pair(status, val);
				output_data_delayer.set(0, new_status_pair);
				status_pair old_status_pair = output_data_delayer.get()[0];
		
				void *this_is_void = NULL;						
				rval = status_vector.activate_status(old_status_pair.status, old_status_pair.val, readonly, this_is_void/*, &output_data_delayer*/);			
			}
			else
			{
				void *this_is_void = NULL;					
				rval = status_vector.activate_status(status, val, readonly, this_is_void/*, &output_data_delayer*/);
			}
		}
	
		return rval;
	};
	
	///########################################################################
	
	static V leia_joone_kalle(IN unsigned char* C pixels, INOUT float *prev_sum_for_row, OUT A &joone_kalle, OUT B &joon_leitud, OUT B &all_rows_found)
	{
	
		
		
	
		const int max_rows = 5;
		const int max_cols = 15;
		const int middle_col = max_cols / 2;
	
	
		//int col, row;
		float fcol, frow;
		unsigned char r, g, b;
		//float gf;
		//int input_i = 0;
		
		FOR(row, max_rows)
		{
			bool joon_leitud_for_row = false;
			A rows_sum = 0;
			
		
			FOR(col, max_cols)
			{
				r = pixels[row * max_cols * 3 + col * 3 + 2];
				g = pixels[row * max_cols * 3 + col * 3 + 1];
				b = pixels[row * max_cols * 3 + col * 3 + 0];	
				
				if (g > 128)
				{
					joon_leitud_for_row = true;
				
					fcol = (float)col;
					frow = (float)row;
				
					rows_sum += (fcol - middle_col) * ((middle_col - frow) / 5);	  ///lower rows have less meaning
					joon_leitud = true;
				}
				
				
#if 0					
					gf = (float)g / 255;
#if SEND_CAMERA_IMAGE_TO_NET					
					values_in.set_item_atindex(NUM_NET_BASE_INPUTS + input_i, gf);
#endif					
					input_i++;			///was col_i: TODO: now I switched row and col loops, so this section must be updated accordingly
#endif				
			}	
			
			
			if (!joon_leitud_for_row)
			{
				rows_sum = prev_sum_for_row[row];	
				
				all_rows_found = false;	
			}					
			else
			{
				prev_sum_for_row[row] = rows_sum;
			}
			
			joone_kalle += rows_sum;
		
		}
			
	};

	///########################################################################

	A recalc_sa_output_val(A sa_planned_output_val, S output_index) C
	{
	
		MYASSERT((size_t)output_index <= (NUM_OUTPUTS - 1));
		
		
		if (NUM_OUTPUTS == 1)
		{
		
			statuses planned_status;
			
			if (sa_planned_output_val < -0.25)
			{
				planned_status = TURN_LEFT;
			}
			else if (sa_planned_output_val > 0.25)
			{
				planned_status = TURN_RIGHT;
			}
			else 
			{
				planned_status = STRAIGHT;
			}		
		
			//turnpercentage = 1.0;
			//activate_status(my_status_vector, status, 1.0);
			
		#if 0
		
			A actual_output_val = activate_status(my_status_vector, planned_status, 1.0, TRUE);
		
		#else
		
			A actual_output_val = sa_planned_output_val;
			if (planned_status == STRAIGHT)
				actual_output_val = 0;
		
		#endif
			
			
			return actual_output_val;
		}
		else if (NUM_OUTPUTS == 2)
		{
			statuses planned_status;
			
			if (output_index == 0)
			{
				if (sa_planned_output_val > 0.25)
				{
					planned_status = TURN_RIGHT;
				}
				else 
				{
					planned_status = STRAIGHT;
				}
			}
			else if (output_index == 1)
			{
				if (sa_planned_output_val > 0.25)
				{
					planned_status = TURN_LEFT;
				}
				else 
				{
					planned_status = STRAIGHT;
				}
			}
			else
			{
				planned_status = STRAIGHT;
				
				MYASSERT(false);
			}
			
			
		#if 0
		
			A actual_output_val = activate_status(my_status_vector, planned_status, 1.0, TRUE);
		
		#else
		
			A actual_output_val = sa_planned_output_val;
			if (planned_status == STRAIGHT)
				actual_output_val = 0;
		
		#endif
			
			
			return actual_output_val;		
		}
		else
		{
			MYASSERT(false);
			
			return 0;
		}
		
	};

	///########################################################################

public:

	void onKeyPressed(int key)
	{
	
		switch(key)
		{
			case 0:						 ///   0 / Ins
			case 10:					 ///   comma / Del
				//break;
		
		
			case 1:
			case 4:
			case 7:
			case 8:
			case 9:
			case 6:
			case 3:
			case 2:
			
			#if TEST_LINEFOLLOWER
				if (status == MANUAL_PAUSE)
					status = STOP;		 //allow continuing	 				
			#endif
				
				lastkeypress = key;	 				
				break;


			case 5:
			#if TEST_LINEFOLLOWER
				status = MANUAL_PAUSE;
			#else
				lastkeypress = key;	 
			#endif
				break;
		
		
			default:
				break;		
		};		
	
	};

	///########################################################################

	void execute()
	{
	
	
		
	
		//return;
		using namespace std;
		using namespace curses;
		using namespace ai;
		
		
		
		
		
		
		
	
		step = getSimulationStep();
		step_complete = false;
		
		
		
		if (start_simulationstep == -1)
		{
			start_simulationstep = step;
			step = 0;
		}
		else
		{
			step = step - start_simulationstep;
		}
		
		
		
		
#if USE_BLENDED_STATUS_VECTOR		
		A leftmotor_speed = 0;
		A rightmotor_speed = 0;
#endif		

		//linked_list::float_a values_in;
		
		
		input_values_a_T values_in;

		PIXEL_A<unsigned char, 15, 5> pixels2;
		//static PIXEL_A<unsigned char, 15, 5> pixels2_old;
		
			
		
		
		
		
		sprintf(buf, "--> step nr: %d", step);
		printLn(buf);
		
		
		
		
		
		
																 
		
		int sensorID;					   
        //float value;
        //bool collision;
        
		static bool button_exit_click = true;		///lets set them to true, so that the button must be free at least for one cycle before it can be considered clicked after the start of program. This avoids stuck buttons
        static bool button_load_click = true;
        static bool button_save_click = true;
        static bool button_predict_click = true;
        static bool button_learn_click = true;

		static S action_complete_paused_steps = -1;

        
        //Vector3d position;
        unsigned char* pixels = NULL;
        //long li;
        
        
        
        enable_printLn();
        //disable_printLn();
        	
#if 1		
		sensorID = getSensorportId("tasandid_scene.robot1.button_exit.click");			//button
        getSensorValue(sensorID, button_exit_click);	
        if (button_exit_click)
			exitflag = true;
#endif	





        bool button_load_click_prev = button_load_click;
        bool button_save_click_prev = button_save_click;
        bool button_predict_click_prev = button_predict_click;
        bool button_learn_click_prev = button_learn_click;


		sensorID = getSensorportId("tasandid_scene.robot1.button_load.click");			//button
        getSensorValue(sensorID, button_load_click);	
        if (button_load_click && !button_load_click_prev)
        {
			buttonclick_laststatus = status;

			this->load_net();	
			this->init_net();	
			button_reaction();
			
			status = BUTTONCLICK_PAUSE__NET_LOADED;
			steps_occured = true;
			goto output_status_to_client;
		}
		
		sensorID = getSensorportId("tasandid_scene.robot1.button_save.click");			//button
        getSensorValue(sensorID, button_save_click);	
        if (button_save_click && !button_save_click_prev)
        {
			buttonclick_laststatus = status;

			this->save_net();		
			button_reaction();
			
			status = BUTTONCLICK_PAUSE__NET_SAVED;
			steps_occured = true;
			goto output_status_to_client;
		}



		sensorID = getSensorportId("tasandid_scene.robot1.button_predict.click");			//button
        getSensorValue(sensorID, button_predict_click);	
        if (button_predict_click && !button_predict_click_prev && (this->mode != MODE_PREDICT))
        {
			this->mode = MODE_PREDICT;		
			button_reaction();
			
			my_status_vector.reset_status_values();		//NB!
			
			steps_occured = true;
			goto output_status_to_client;
		}
		
		sensorID = getSensorportId("tasandid_scene.robot1.button_learn.click");			//button
        getSensorValue(sensorID, button_learn_click);	
        if (button_learn_click && !button_learn_click_prev && (this->mode != MODE_LEARN))
        {
			this->mode = MODE_LEARN;		
			button_reaction();
			
			steps_occured = true;
			goto output_status_to_client;
		}









		
		
		if ((status == BUTTONCLICK_PAUSE) || (status == BUTTONCLICK_PAUSE__NET_LOADED) || (status == BUTTONCLICK_PAUSE__NET_SAVED))
		{
			if ((buttonclick_pause_counter > 0) || (steps_occured))				//save status is not shown in the console screen yet
			{
				buttonclick_pause_counter--;
				
				goto output_status_to_client;
			}
			else
			{
				///continue
				
				status = buttonclick_laststatus;
			}
		}
		

		if (status == MANUAL_PAUSE)
		{
			goto output_status_to_client;
		}
		
				
		





					 											   
#if 0		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.button1.click");			//button
        getSensorValue(sensorID, buttonclick);		
		sprintf(buf, "Button1: %s", buttonclick ? "click" : "free");
		printLn(buf);		
		
		
		
		
        sensorID = getSensorportId("B-Smart.robot1.centerMarker.GPS.position");
        getSensorValue(sensorID, position);        	
		sprintf(buf, "GPS: x(%f) y(%f) z(%f)", position.v[0], position.v[1], position.v[2]);
		printLn(buf);		
#endif		
		
		
		
		



				
		
		
		
		
		
		disable_printLn();
		
		
		
		
		
		
		
		enable_printLn();





		bool manual_control = false;
		bool suppress_learning = false;
		bool emergency = false;
		
		
		
		bool reinforcement = false;
		
		
	
	#if TEST_INTERVAL_SCHEDULE
		
		IFC (1 && (interval_measure.get() >= reinforcement_interval) && (status == TURN_RIGHT))		
		{
			//operant_actual_value += reinforcement_size;
			//reinforcement = true;
			
			reinforcement_is_scheduled = true;								   ///TODO: why doesnt net learn when this is done here?
		}
		
	#endif
		
		
		
	#if TEST_RATIO_SCHEDULE
		
		IFC (status == TURN_RIGHT)		
		{
			//operant_actual_value += reinforcement_size;
			//reinforcement = true;
			
			ratio_tick_is_scheduled = true;								   ///TODO: why doesnt net learn when this is done here?
		}
		
	#endif
		
		
		
		
		//values_in.set_num_items(NUM_NET_BASE_INPUTS);
		//FOR(i, NUM_NET_BASE_INPUTS)
		//	values_in[i] = 0;
		values_in.init();
		
		

		IFC(TEST_LINEFOLLOWER || !USE_DISCRIMINANT_NET)
		{
			#include "joonejalgija.h"
		}
		else
		{
			//#include "operantsus.h"
			
			
			
			values_in.set_item_atindex(0, TA(0));
			values_in.set_item_atindex(1, TA(0));
			values_in.set_item_atindex(2, TA(0));

			
			if (lastkeypress != -1)
			{
				manual_control = false;
				
				
				
				
				switch(lastkeypress)
				{
				
					case 1:
						discriminant1 = 1;
						break;
						

					case 5:
						discriminant2 = 1;
						break;
						

					case 3:
						discriminant3 = 1;
						break;




					case 0:				   ///   0 / Ins
						discriminant1 = 0;
						break;
						
						
					case 2:				   ///   0 / Ins
						discriminant2 = 0;
						break;


					case 10:			   ///   comma / Del
						discriminant3 = 0;
						break;
				


					
					case 4:
						operant_actual_value += -reinforcement_size;
						//operant_preferred_value = 1; 
						break;			
					

					case 6:
						operant_actual_value += reinforcement_size;
						reinforcement = true;
						//operant_preferred_value = 0;
						break;


					
					
					case 7:
						manual_control = true;
						status = TURN_LEFT;
						break;
					
					
					case 8:
						manual_control = true;
						status = STRAIGHT;
						break;


					case 9:
						manual_control = true;
						status = TURN_RIGHT;
						break;
						
					
						
					
					default:
						break;			
				}	
				
				
				
				
					
			
			
				lastkeypress = -1;
			}	
			
			
			
			//interval_measure.tick(!reinforcement);
			
			
		
		
		
		
			//bool reinforcement2 = false;
			//static A operant_actual_value__prev = initial_operant_actual_value;
			
			if (operant_actual_value > operant_actual_value__prev)
			{
				reinforcement = true;
				operant_actual_value__prev = operant_actual_value;
				
			#if TEST_INTERVAL_SCHEDULE
				discriminant3 = 1;
			#endif
				
				mybeep();
			}
			
			
			
			interval_measure.tick(!reinforcement);
			
			
			
			
		///##################################################################  	


			
			
			
			#if TEST_INTERVAL_SCHEDULE
			
				values_in.set_item_atindex(0, interval_measure.get());
				
				values_in.set_item_atindex(1, TA(discriminant2));
				values_in.set_item_atindex(2, TA(discriminant3));					
			
			#elif TEST_RATIO_SCHEDULE
			
				if (reinforcement)
				{
					discriminant1 = 0;
					discriminant2 = 0;
					discriminant3 = 0;
					
					ratio_ticks = 0;
					ratio_tick_is_scheduled = false;
					reinforcement_is_scheduled = false;
				}
			
				values_in.set_item_atindex(0, TA(discriminant1));
				values_in.set_item_atindex(1, TA(discriminant2));
				values_in.set_item_atindex(2, TA(discriminant3));					
			
			#else				
			
				values_in.set_item_atindex(0, TA(discriminant1));
				values_in.set_item_atindex(1, TA(discriminant2));
				values_in.set_item_atindex(2, TA(discriminant3));
				
			#endif
					
					
	
		
		
		
		
			//net->set_inputs(values_in);
			
			
			
			
			
		///##################################################################  	
		
			
			
			
			//if (reinforcement2 || ((manual_control || action_was_complete) && (status != ACTION_COMPLETE_PAUSE)))
			//if (1 || reinforcement2 || ((manual_control || action_was_complete)))
			{
				//testseries_logger << "\n";
				
				SFOREACH2(input_values_a_T, &values_in)
				{
					testseries_logger << (input_values_a_T::elem_T)(*item) << "\t";
				}	   
				
				
				#if USE_OPERANT_NET					
				
					testseries_logger << operant_preferred_value << "\t";
					testseries_logger << operant_actual_value << "\t";
					
					testseries_logger << (reinforcement ? 1 : 0) << "\t";
				
				#endif
				
				
			
				if (/*(manual_control || action_was_complete) && */(status == TURN_RIGHT))
				{
					action_counter1 += 1 / duration_one_timesteps_quota / (use_action_duration - 0.25);
				}
				
				if (/*(manual_control || action_was_complete) && */(status == TURN_LEFT))
				{
					action_counter2 += 1 / duration_one_timesteps_quota / (use_action_duration - 0.25);
				}
				
				
				testseries_logger << action_counter1 << "\t";	
				
				if (NUM_OUTPUTS == 2)		
					testseries_logger << action_counter2 << "\t";	
					
					
				testseries_logger << endl;		
			}		


	///##################################################################  	



		}		///if: joonejalgija / operantsus



	///##################################################################  	


		
/*		
		if (status == ACTION_COMPLETE_PAUSE)
		{
			if (action_complete_paused_steps == -1)
			{
				action_complete_paused_steps = pause_after_every_action; 
			}
			
			
			action_complete_paused_steps--;
			
			
			if (manual_control || (action_complete_paused_steps == 0))
			{
				action_complete_paused_steps = -1;
				
				status = STOP;
			}
			
			if (!manual_control)
			{		
			
				this->get_net_inputsoutputs_for_console(true);	 		
				steps_occured = true;					//lets update console

			
				goto output_status_to_client;
			}
		}
*/		
			
		
		
	///##################################################################  		
		
		
		

		
		

/*

	NET:		
	- set_inputs
	- set_outputs
	- tick_echo_lines					//move data from input cells to first echoline cells, as input cells should not have assoc_lines anymore
	- calc_predictions
	- get_outputs
	- update_corrs
	- prepare_for_next_cycle
	
*/							

		
		
		
		//m_log << left_signal << "\t" << middle_signal << "\t" << right_signal << "\t";
		
		
		
		
		
		//prevmode = MODE_LEARN;					
		if (prevmode != mode)							//give it a start on predict mode 
		{
			//net->set_output_atindex(2, /*TA((status == STRAIGHT) ? 1 : 0)*/1);	
			#ifndef USE_OPERANT_NET
			my_status_vector.reset_status_values();
			#endif
			//my_status_vector.activate_status(STRAIGHT);  
		}
		
		prevmode = mode;
		
		
		
#if 0		
				float_a values_out;
				values_out.set_num_items(6);
				values_out.set_item_atindex(0, TA((status == TURN_RIGHT) ? 1 : 0));	
				values_out.set_item_atindex(1, TA((status == STRAIGHT) ? 1 : 0));	
				values_out.set_item_atindex(2, TA((status == TURN_LEFT) ? 1 : 0));				
				values_out.set_item_atindex(3, TA((status == BACKWARDS_STRAIGHT) ? 1 : 0));				
				values_out.set_item_atindex(4, TA((status == STOP) ? 1 : 0));	
				values_out.set_item_atindex(5, TA((status == WAIT_FOR_START) ? 1 : 0));				
				net->set_outputs(values_out);
#else





	#if !USE_OPERANT_NET
		if ((mode == MODE_LEARN)/* || emergency*/ || manual_control)
		{
			my_status_vector.reset_status_values();
			activate_status(my_status_vector, status, 1.0);
		}
	#endif		
		
		
		
//#endif		
		
		
	
	///##################################################################
		
		

	
#if USE_OPERANT_NET		

		net->set_operant_preferred_cv_atindex(0, operant_preferred_value);
		//net->set_operant_preferred_cv_atindex(1, cell_value(0));

		IFC (1)
		{
			//net->set_operant_actual_cv_atindex(0, operant_actual_value);
			operant_data_delayer.set(0, operant_actual_value);
			net->set_operant_actual_cv_atindex(0, operant_data_delayer.get()[0]);
			
			
			//net->set_operant_actual_cv_atindex(1, cell_value(0));
		}
		
		
		
		
		/*else
		{
					if (joon_leitud)
					{
						net->set_operant_actual_cv_atindex(0, cell_value(joone_kalle));
						//net->set_operant_actual_cv_atindex(1, cell_value(0));
					}
					else
					{
						//net->set_operant_actual_cv_atindex(0, cell_value(joone_kalle));
						//net->set_operant_actual_cv_atindex(1, cell_value(1));
					}		
		}*/	
			
#endif	
		
		
				
				
	///##################################################################
	///
	///##################################################################  		



				
				



//#if !USE_OPERANT_NET
		if (/*1 && */(step < 10))											 
		{
			status = WAIT_FOR_START;
			///delete pixels;
			goto e_control_calc2;					   
		}
//#endif		





	///##################################################################
	///
	///##################################################################  		
		



		if (status == ACTION_COMPLETE_PAUSE)
		{
			if (action_complete_paused_steps == -1)
			{
				action_complete_paused_steps = pause_after_every_action; 
			}
			
			
			action_complete_paused_steps--;
			
			
			if (manual_control || (action_complete_paused_steps == 0))
			{
				action_complete_paused_steps = -1;
				
				status = STOP;
				
			#if TEST_INTERVAL_SCHEDULE				
				//discriminant2 = 1;
				//values_in.set_item_atindex(1, TA(discriminant2));
				
				
				
			#endif
			}  
			
			
		#if 1
		
			if (!manual_control)
			{		
				//net->set_output_atindex(0, 0.0f);	
				activate_status(my_status_vector, status, 1.0f);
			
			
			
				this->get_net_inputsoutputs_for_console(true);	 		
				steps_occured = true;					//lets update console

			
				goto output_status_to_client;
			}
		
		#endif
		
		}
		
		
	#if TEST_INTERVAL_SCHEDULE
		if (status == TURN_RIGHT)					///reinforcement has ended
		{
			discriminant3 = 0;										///its already stored in values_in
		}
	#endif
		

		
		
	///##################################################################
	///
	///##################################################################  		
		
		
		
		input_data_delayer.set(values_in);
		net->set_inputs(input_data_delayer.get());
		
		
		//werase(win);
		
				
				
						
		net->tick_lines();
		
		
		
		
		
	
	
	///##################################################################
	///
	///##################################################################  		
												 		
		
		
		
		
		
		
#if !USE_OPERANT_NET	

		net->calc_predictions();
		

		if ((mode == MODE_LEARN)/*|| emergency*/ || manual_control)
		{
			net->update_corrs();
		}
		else
		{
	//#if USE_OPERANT_NET
	//		///net->calc_operant_predictions();	///for operant net you must call after calc_predictions() either update_corrs() or calc_operant_predictions() 	
	//		net->update_corrs();
	//#endif		
		}
#else

		chart_futurelines(0, 0, 0);			///move prev val to left
		
		chart_energy_levels(true);
		
		

		if (((mode == MODE_LEARN)/*|| emergency*/ || manual_control) && !suppress_learning)
		{
			IFC (ENABLE_UPDATE_CORRS_DURING_MANUAL_CONTROL || !TEST_LINEFOLLOWER || !manual_control)
			{
				if (/*(reinforcement && (status == ACTION_COMPLETE_PAUSE)) || */action_complete || ENABLE_UPDATE_CORRS_DURING_INCOMPLETE_ACTION)
					net->update_corrs();	///for operant net you must call after calc_predictions() either update_corrs() or calc_operant_predictions() 	
			}
			
			net->calc_predictions();			
			
			
			if (!manual_control)
			{
				
				if ((status != ACTION_COMPLETE_PAUSE) && (!BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE || action_complete))
				{			
				
					#if TEST_INSIGHT
					if (discriminant2)										///enable insight only after users request	
					#endif			 			
						//net->calc_operant_predictions(&operants2, recalc_sa_output_val);
						net->calc_operant_predictions(&operants2, boost::bind(boost::mem_fn(&my_T::recalc_sa_output_val), this, _1, _2));	
					
					//action_complete = false;	
				}
				
			}
			else
			{
				action_complete = true;
			
			
				IFN (ACTION_STRENGTH_MEANS_ACTION_DURATION, my_status_vector.reset_status_values());
				activate_status(my_status_vector, status, 1.0);
					
				//net->outputs_tick_echolines_first_cell();				
				//net->tick_echolines_first_cell();		///must tick all echolines because during manual control s.a is suppressed and inputs too are yet unticked
			}
		}
		else
		{
			net->calc_predictions();
			//net->calc_operant_predictions(&operants2, recalc_sa_output_val);
			
			
			if (!BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE || action_complete)
			{
				net->calc_operant_predictions(&operants2, boost::bind(boost::mem_fn(&my_T::recalc_sa_output_val), this, _1, _2));
				
				//action_complete = false;
			}
		}
		
		
		
		
		net->get_inputoutputs_energy_levels_for_charts(&inputoutputs_energy_levels);
		
		chart_energy_levels();
		
		
		
		chart_futurelines(0, 1, 0);
		
		chart_futurelines(1, 0, 1);
		chart_futurelines(2, 1, 1);
		chart_futurelines(3, 2, 1);
		chart_futurelines(4, 3, 1);
		//chart_futurelines(5, 4, 1);
		
		chart_futurelines(5, 0, 2);
		chart_futurelines(6, 1, 2);
		chart_futurelines(7, 2, 2);
		chart_futurelines(8, 3, 2);
		//chart_futurelines(5, 4, 2);
		
		
#endif		
		
		
		
		
		
		
		
	///##################################################################  		
	///	
	///##################################################################  		
		
		
		//linked_list::float_a values_out2;			  
		//net->get_outputs(&values_out2);
		
		
		
		
		disable_printLn();
		
		sprintf(buf, "net status predictions:");
		sprintf(buf, "%s\r\nTURN_LEFT = %f",				buf, my_status_vector.get_status_val(TURN_LEFT));
		sprintf(buf, "%s\r\nSTRAIGHT = %f",				buf, my_status_vector.get_status_val(STRAIGHT));
		sprintf(buf, "%s\r\nTURN_RIGHT = %f",				buf, my_status_vector.get_status_val(TURN_RIGHT));
		sprintf(buf, "%s\r\nSTOP = %f",					buf, my_status_vector.get_status_val(STOP));
		//sprintf(buf, "%s\r\nBACKWARDS_STRAIGHT = %f",		buf, my_status_vector.get_status_val(BACKWARDS_STRAIGHT));
		sprintf(buf, "%s\r\nWAIT_FOR_START = %f",			buf, my_status_vector.get_status_val(WAIT_FOR_START));
		printLn(buf);	
		
		
					
		
	///##################################################################
	///
	///##################################################################  		
												 		
		
		
	#if 0
	
		if (status == ACTION_COMPLETE_PAUSE)
		{
			/*if (action_complete_paused_steps == -1)
			{
				action_complete_paused_steps = pause_after_every_action; 
			}
			
			
			action_complete_paused_steps--;
			
			
			if (manual_control || (action_complete_paused_steps == 0))
			{
				action_complete_paused_steps = -1;
				
				status = STOP;
			}  */
			
			if (!manual_control)
			{		
				//net->set_output_atindex(0, 0.0f);	
				activate_status(my_status_vector, status, 1.0f);
			
			
			
				this->get_net_inputsoutputs_for_console(true);	 		
				steps_occured = true;					//lets update console

			
				goto output_status_to_client;
			}
		}
		
	#endif
		



	///##################################################################  		









	
	
	
#if USE_BLENDED_STATUS_VECTOR		
		{
			linked_list::float_a param_vals;
			my_status_vector.get_blended_status_params(&param_vals, LEFT_MOTOR, RIGHT_MOTOR, -1);
			
			ai::flist(&leftmotor_speed, &rightmotor_speed, NULL) = param_vals;
			
			sprintf(buf, "net predictions: L(%f) R(%f)", leftmotor_speed, rightmotor_speed);
			printLn(buf);		
		}
		
		status = STRAIGHT;
#else






		//status = STOP;

#pragma warning (push)
#pragma warning (disable : 4127)		///warning C4127: conditional expression is constant
		if ((!manual_control || (use_action_duration > 0)) && !emergency && ((mode == MODE_PREDICT) || (USE_OPERANT_NET)))		 ///for operant net outputs must be read after calling calc_operant_predictions()
#pragma warning (pop)
		{

			IFC(1 || (NUM_NET_BASE_OUTPUTS == 1))
			{
			
				
				//cell_value status_cv = my_status_vector.get_status_cv(0);
				//cell_value status_cv = my_status_vector.net->get_output_atindex(0);
				cell_value status_cv = my_status_vector.get_output();
				A status_a = status_cv.mean();	
				
				
				/*
				if (NUM_OUTPUTS == 2)
				{
					cell_value status_cv2 = my_status_vector.net->get_output_atindex(1);
					A status_a2 = status_cv2.mean();	
				}
				*/
				
					
				
				
				static A last_status_a = 0;
				bool action_was_complete = false;
				
				
				if (!BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE || action_complete)
				{
					last_status_a = status_a;
					action_complete = false;
					action_was_complete = true;
				}									  
				
				
				
				status_a = last_status_a;
				
				
			#if !ACTION_STRENGTH_MEANS_ACTION_DURATION
			
				if (!manual_control)
				{
					if (status_a < -0.25f)
					{
						status = TURN_LEFT;
						//turnpercentage = ((-status_a) - 0.5) + 0.25;
						turnpercentage = (-(status_a + 0.25f) / 0.75f) + 0.25f;
					}
					else if (status_a > 0.25f)
					{
						status = TURN_RIGHT;
						//turnpercentage = (status_a - 0.5) + 0.25;
						turnpercentage = (status_a - 0.25f) / 0.75f + 0.25f;
					}
					else 
					{
						status = STRAIGHT;
						turnpercentage = 1.0f;
					}
				}
				else
				{
					turnpercentage = 1.0f;
				}	
				
				action_complete = true;
				
				
			#else
			
				if (!manual_control)
				{
					if (status_a < -0.25f)
					{
						status = TURN_LEFT;	
					}
					else if (status_a > 0.25f)
					{
						status = TURN_RIGHT;
					}
					else 
					{
						status = STRAIGHT;
					}		
				}
				
			
				turnpercentage = 1.0f;
				A actual_action = activate_status(my_status_vector, status, 1.0f);
				
				
				
				//action_complete = false;
				
				if (status == TURN_LEFT)
				{
					if (use_action_duration != 0)
						last_status_a = -use_action_duration;
						
					last_status_a = maxf(last_status_a, -1.0f);				///lets limit our grandiose dreams
				
					if (actual_action <= last_status_a)
						action_complete = true;
				}
				else if (status == STRAIGHT)
				{
					MYASSERT(actual_action == 0);
				
					if (actual_action == 0)
						action_complete = true;
				}
				else if (status == TURN_RIGHT)
				{
					if (use_action_duration != 0)
						last_status_a = use_action_duration;
						
					last_status_a = minf(last_status_a, 1.0f);				///lets limit our grandiose dreams
				
					if (actual_action >= last_status_a)
						action_complete = true;
				}
				
				
				
				
				/*
				bool reinforcement2 = false;
				static A operant_actual_value__prev = operant_actual_value;
				
				if (operant_actual_value > operant_actual_value__prev)
				{
					reinforcement2 = true;
					operant_actual_value__prev = operant_actual_value;
				}
				
				
				//if (reinforcement2 || ((manual_control || action_was_complete) && (status != ACTION_COMPLETE_PAUSE)))
				if (reinforcement2 || ((manual_control || action_was_complete)))
				{
					//testseries_logger << "\n";
					
					SFOREACH2(input_values_a_T, &values_in)
					{
						testseries_logger << (input_values_a_T::elem_T)(*item) << "\t";
					}	   
					
					
					#if USE_OPERANT_NET					
					
						testseries_logger << operant_preferred_value << "\t";
						testseries_logger << operant_actual_value << "\t";
						
						testseries_logger << (reinforcement2 ? 1 : 0) << "\t";
					
					#endif
					
					
				
					if ((manual_control || action_was_complete) && (status == TURN_RIGHT))
					{
						action_counter++;
					}	 	
					
					
					testseries_logger << action_counter << endl;			
				}
				*/
				
				
				/*if (action_was_complete)
				{
					
				}  */
				
				
				
				
				if (action_complete)
				{
					MYASSERT(BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE);
				
					my_status_vector.reset_status_values2();
										
					
					if (pause_after_every_action > 0)
					{
						if (status != STRAIGHT)
						{
							status = ACTION_COMPLETE_PAUSE;
							
						
						#if TEST_RATIO_SCHEDULE
							if (ratio_tick_is_scheduled)
							{
								ratio_ticks++;
							
								ratio_tick_is_scheduled = false;
								
								
								if (ratio_ticks == 1)
								{
									discriminant1 = 1;
								}
								else if (ratio_ticks == 2)
								{
									discriminant1 = 0;
									discriminant2 = 1;
								}
								else if (ratio_ticks == 3)
								{
									discriminant2 = 0;
									discriminant3 = 1;
								}
								else if (ratio_ticks == 4)
								{
									discriminant3 = 0;
								}
							}
							
							
							if (ratio_ticks == reinforcement_ratio)
							{
								reinforcement_is_scheduled = true;
								
								ratio_ticks = 0;
							}
						#endif
							
							
							if (reinforcement_is_scheduled)
							{
								operant_actual_value += reinforcement_size;
								reinforcement = true;
								
								reinforcement_is_scheduled = false;
							}
						}
						else
						{
							status = STOP;
						}
					}
				}
				else
				{
					//if ((status == STRAIGHT) && (pause_after_every_action > 0))
					//	status = ACTION_COMPLETE_PAUSE;
				}
				
				
				
				//if (!BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE)
				//	action_complete = true;
					
				
				
			#endif	
			
			
			}
			else   ///IFC(NUM_NET_BASE_OUTPUTS == 1)
			{
				MYASSERT(!ACTION_STRENGTH_MEANS_ACTION_DURATION);
				

				cell_value turn_left = my_status_vector.get_status_cv(TURN_LEFT);
				cell_value turn_left_diff = my_status_vector.get_status_predicted_diff_cv(TURN_LEFT);
				
				cell_value turn_right = my_status_vector.get_status_cv(TURN_RIGHT);
				cell_value turn_right_diff = my_status_vector.get_status_predicted_diff_cv(TURN_RIGHT);
				
				
				///cell_value straight = cvop::mul_through(my_status_vector.get_status_cv(STRAIGHT), 0.1);
				cell_value straight = my_status_vector.get_status_cv(STRAIGHT);
	#if USE_OPERANT_NET												   ///TODO - for operant net, straight could get correlated with any joone_kalle and is not trustable. Why?
				//straight = cvop::mul_through(straight, 0.2);
				A straight_EX = straight.EX();
				straight_EX = 1 - turn_left.EX() - turn_right.EX();
				
				#if (0 || 0 && TEST_LINEFOLLOWER)														
					///net has no ability to learn concurrent influences of outputs. Therefore it does not understand the concept "STRAIGHT" overrides "LEFT" or "RIGHT". As straight itself predicts nothing (its in the middle of left or right) then it can weaken left or right directed actions without net understanding (and therefore preventing during s.a) that
					straight = cell_value_EXDX(straight_EX, straight.n() / 100, straight.DX() * 100);
				#endif
	#endif			
				
				
				
				
				cell_value left_right_differential = cvop::sub_considering_importance(turn_left, turn_right);		
				cell_value left_right_diff_differential = cvop::sub_considering_importance(turn_left_diff, turn_right_diff);	
						  		
				//cell_value turn_straight_differential  = cvop::sub_considering_importance(cvop::abs(left_right_differential), straight);
				
				cell_value left_straight_differential = cvop::sub_considering_importance(turn_left, straight);
				cell_value right_straight_differential = cvop::sub_considering_importance(turn_right, straight);
				
				
				//if (0 || turn_straight_differential.overnull())		//turn
				if (left_straight_differential.overnull() || right_straight_differential.overnull())
				{
					if (left_right_differential.overnull())
					//if (left_right_diff_differential.overnull())
					{
						status = TURN_LEFT;
						
						//turnpercentage = turn_left.mean() + 0.25;
	#if !USE_OPERANT_NET					
						turnpercentage = left_right_differential.mean() * 5 + (float)0.25;
	#else
						turnpercentage = left_right_differential.mean();
	#endif					
					}
					else if (left_right_differential.undernull())
					{
						status = TURN_RIGHT;
						
						//turnpercentage = turn_right.mean() + 0.25;
	#if !USE_OPERANT_NET										
						turnpercentage = -left_right_differential.mean() * 5 + (float)0.25;
	#else
						turnpercentage = -left_right_differential.mean();
	#endif					
					}	
					else
					{																   
						status = STRAIGHT;
						turnpercentage = 1;			///for activate_status call
					}													 
					
					/*
					if (turn_straight_differential.overnull())
						turnpercentage = turnpercentagec1;
					else
						turnpercentage = turnpercentagec2;
						*/
					
					turnpercentage = minf(turnpercentage, 1.5);			///lets limit our simulated crazyness	
					
				}
				else
				{
					status = STRAIGHT;
					turnpercentage = 1;			///for activate_status call
				}
					


				///net has no ability to learn concurrent influences of outputs. Therefore it does not understand the concept "LEFT" overrides "RIGHT" or "STRAIGHT". When left and right have similar values, then they can weaken each other - both left or right directed actions will be suppressed without net understanding it (and therefore preventing during s.a) and possibly learning that left turn caused right turn not-resulting, instead of learning that right really is not-resulting to some subgoal
				my_status_vector.reset_status_values();
				activate_status(my_status_vector, status, turnpercentage);		  ///TODO: is this ok that we do maths with turnpercentage before sending it back to net? In some sense it is, because the actual turnpercentage is what causes results in simulated world. In an other sense it is not, because then simulated annealing cannot correctly predict values for actions that need not only decising between right-left directed actions, but need also precise amounts of energy on one or other direction. SOLVED: operant controller does not transform the turnpercentage
				
				//net->outputs_tick_echolines_first_cell();
				//net->tick_echolines_first_cell();		///must tick all echolines because during manual control s.a is suppressed and inputs too are yet unticked
				
			}		///#if (NUM_NET_BASE_OUTPUTS == 1)			
						
		}													   
		else
		{
			if (manual_control)
				turnpercentage = 1;
		}
		
		
	#if 0		//just for template

		///max kalle = +/- 21
		
		
		if (joone_kalle < 0)		///joon on vasakul, seega ka robot peab prama vasakule
		{
			status = TURN_LEFT;
			turnpercentage = -joone_kalle / 21 + 0.25;
			
			laststatus = status;
			
			
			left_signal = -joone_kalle / 21;				
		}
		else if (joone_kalle > 0)		///joon on paremal, seega ka robot peab prama paremale
		{
			status = TURN_RIGHT;
			turnpercentage = joone_kalle / 21 + 0.25;
			
			laststatus = status;
			
			
			right_signal = joone_kalle / 21;
		}	
		else if (joone_kalle == 0)
		{
			if (joon_leitud)
			{
				status = STRAIGHT;
				
				
				middle_signal = 1;
			}
			else
			{
				//status = WAIT_FOR_START;
				status = laststatus;
				turnpercentage = 1.5;
			}
		}
	#endif		
		


		
#endif
		
		
		
		
		
		
		
	///##################################################################  		
	///	
	///##################################################################  		
		
		

		
		
//#if !USE_OPERANT_NET			
e_control_calc2:		
//#endif



		
		
		
		
		this->get_net_inputsoutputs_for_console(true);	 		
		steps_occured = true;					//lets update console
		
		
		
		IFC(output_classified_innercells)
			this->output_classified_innercells_to_console();
		
		
		
		
		
		
		net->prepare_for_next_cycle();		   ///must be called as last call in cycle, or first call in next cycle
		
		
		
		
		

	///##################################################################  		
	///	
	///##################################################################  		
		
		
#endif		//#if USE_NET			
		
		


output_status_to_client:		
		
		
		disable_printLn();
		
		sprintf(buf, "turn_counter, turn_recovery_counter: %d : %d", turn_counter, turn_recovery_counter);
		printLn(buf);
		
		
		
		
		
		int leftmotor1 = getActuatorportId("tasandid_scene.robot1.wheel1.motorVelocity");
		int leftmotor2 = getActuatorportId("tasandid_scene.robot1.wheel2.motorVelocity");
		int rightmotor1 = getActuatorportId("tasandid_scene.robot1.wheel3.motorVelocity");
		int rightmotor2 = getActuatorportId("tasandid_scene.robot1.wheel4.motorVelocity");
		
		
		
		
		
		
		
		float turnpercentage2;
		if (turnpercentage > 1)
		{
			turnpercentage2 = turnpercentage - 1;
			turnpercentage = 1;
		}
		else
		{
			turnpercentage2 = 0;
		}
		
		
		#if ACTION_STRENGTH_MEANS_ACTION_DURATION
			turnpercentage = 1.15;	
			turnpercentage2 = 0.02;	
		#endif
		

#if USE_BLENDED_STATUS_VECTOR
		if (mode == MODE_PREDICT)
		{
			setActuatorport(leftmotor1, leftmotor_speed); 
			setActuatorport(leftmotor2, leftmotor_speed);	 
			setActuatorport(rightmotor1, rightmotor_speed);
			setActuatorport(rightmotor2, rightmotor_speed);
			
			turn_recovery_counter = 0;
			
			printLn("MODE_PREDICT");				
		}
		else 
#endif		
		if (status == TURN_RIGHT)
		{
			setActuatorport(leftmotor1, 100 * turnpercentage); 
			setActuatorport(leftmotor2, 100 * turnpercentage);	 
			setActuatorport(rightmotor1, 100 * turnpercentage2);
			setActuatorport(rightmotor2, 100 * turnpercentage2);
			
			turn_recovery_counter++;
			
			
			printLn("TURN_RIGHT");			
		}
		else if (status == TURN_LEFT)
		{
			setActuatorport(leftmotor1, -100 * turnpercentage2);
			setActuatorport(leftmotor2, -100 * turnpercentage2);
			setActuatorport(rightmotor1, -100 * turnpercentage);	
			setActuatorport(rightmotor2, -100 * turnpercentage);	
			
			turn_recovery_counter--;
			
			
			printLn("TURN_LEFT");			
		}		
		else if (status == STRAIGHT)
		{
			setActuatorport(leftmotor1, 75);
			setActuatorport(leftmotor2, 75);
			setActuatorport(rightmotor1, -75);
			setActuatorport(rightmotor2, -75);
												    
			printLn("STRAIGHT");
		}
		else
		{
			setActuatorport(leftmotor1, 0);
			setActuatorport(leftmotor2, 0);
			setActuatorport(rightmotor1, 0);		
			setActuatorport(rightmotor2, 0);		
			
			printLn("MOTORS OFF");
		}		
		
		
		
		printLn("");
		
#if 0		
		if((step > 20) && (step < 1000))
		{
			int id = getActuatorportId("B-Smart.robot1.wheel1.motorVelocity");
			setActuatorport(id, 90);
			//id = getActuatorportId("B-smart.robot1.wheel2.motorVelocity");
			//setActuatorport(id, 0.02);
			id = getActuatorportId("B-Smart.robot1.wheel3.motorVelocity");
			setActuatorport(id, -90);
		}
		else
		{
			int id = getActuatorportId("B-Smart.robot1.wheel1.motorVelocity");
			setActuatorport(id, 0.0);
			//id = getActuatorportId("B-smart.robot1.wheel2.motorVelocity");
			//setActuatorport(id, 0.02);
			id = getActuatorportId("B-Smart.robot1.wheel3.motorVelocity");
			setActuatorport(id, 0.0);		
		}
#endif		
    
    
    
		if (pixels != NULL)
		{
			delete pixels;			///NB!		
			pixels = NULL;
		}    
		values_in.deinit();
		
    
		step_complete = true;
		
		
		
		
		
		
		
		
		#ifndef _DEBUG
			Sleep(25);
		#else
			//Sleep(5);
		#endif
    
	};

	///##################################################################  		
	
private:
	void init_statuses()
	{
	
		using ai::sv_cvpair;	 
		 
		my_status_vector.set_net(net);		
		//my_status_vector.enum_statuses(STATUSES);  	 
		my_status_vector.set_status_params_for(TURN_LEFT,			sv_cvpair(LEFT_MOTOR, -75	),	sv_cvpair(RIGHT_MOTOR, -75		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(STRAIGHT,			sv_cvpair(LEFT_MOTOR, 100	),	sv_cvpair(RIGHT_MOTOR, -100		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(TURN_RIGHT,			sv_cvpair(LEFT_MOTOR, 75	),	sv_cvpair(RIGHT_MOTOR, 75		), sv_cvpair(-1));
		
	#if !USE_DISCRIMINANT_NET
		my_status_vector.set_status_params_for(STOP,				sv_cvpair(LEFT_MOTOR, 0		),	sv_cvpair(RIGHT_MOTOR, 0		), sv_cvpair(-1));
		my_status_vector.set_status_params_for(WAIT_FOR_START,		sv_cvpair(LEFT_MOTOR, 0		),	sv_cvpair(RIGHT_MOTOR, 0		), sv_cvpair(-1));		
	#endif		
		//my_status_vector.set_status_params_for(BACKWARDS_STRAIGHT,	sv_cvpair(LEFT_MOTOR, -100	),	sv_cvpair(RIGHT_MOTOR, -100		), sv_cvpair(-1));		
	
	};
	
	
};

class TasandidController_Server : public TasandidController_Server_base<> {};

//CONNECT_CONTROLLER_TO_SCENE(BSmartController, "B-Smart");

#if 0

void __cdecl start_controller() 
{
	controller_ptr = new TasandidController_Server();
} 

#else


//CONNECT_CONTROLLER_TO_SCENE(TasandidController_Server, "tasandid_scene");

void __cdecl start_controller()																	
{																						
	controller_ptr = new TasandidController_Server();										
}																						

void __cdecl server_main();
																						
extern void (__cdecl *initapp_func)();														    
extern void (__cdecl *start_func)();														    
																						
/*extern Controller_manager Controller_manager_obj;	*/									
																						
/*Controller_manager::set_start_func(start_controller);*/							    
/*Controller_manager::set_initapp_func(init_func);*/								    

extern long *_crtBreakAlloc_ptr;

///#######################################################################
/// 
///#######################################################################

void close_server()
{
	
	
	BLOCK
	{
		global_executeSemaphore->lock();
			
		if (controller_ptr != NULL)
		{
			delete controller_ptr;
			controller_ptr = NULL;
		}
		
		
		exitflag = true;						///must be set inside the lock in order not to interfere with ongoing message passing
		
		global_executeSemaphore->unlock();
	}
	
	
	
	
	
DISABLE_WARNING(4127)							  ///warning C4127: conditional expression is constant
	while (0 || (exit_progress != -1))
END_DISABLE_WARNING	
	{
		Sleep(1000);
	}
	
}

/*
BOOL SetConsoleCtrlHandler(
    PHANDLER_ROUTINE HandlerRoutine, // handler function
    BOOL Add // add or remove handler
    );
*/

BOOL WINAPI CloseEventHandlerRoutine(DWORD dwCtrlType)   //  control signal type
{
    switch(dwCtrlType)
    {
		case CTRL_C_EVENT:
			return FALSE;
			break;
	        
		case CTRL_BREAK_EVENT:
			return FALSE;
			break;
	        
		case CTRL_CLOSE_EVENT:
			close_server();
			break;
	        
		case CTRL_LOGOFF_EVENT:
			close_server();
			//return FALSE;
			break;
	        
		case CTRL_SHUTDOWN_EVENT:
			close_server();
			break;
	        
		default:
			return FALSE;	 		
    }
    
    return TRUE;
}

///#######################################################################
/// 
///#######################################################################

void __cdecl main()
{

#if _DEBUG
	
	_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*_crtBreakAlloc_ptr = -1;	   ///debug memory leaks

	long *local_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*local_crtBreakAlloc_ptr = *_crtBreakAlloc_ptr;


	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(*_crtBreakAlloc_ptr);

#endif



	init_memory_pool();


																						
	initapp_func = debug_table_thread_init;																
	start_func = start_controller;															
	
	
	
	SetConsoleCtrlHandler
	(
		CloseEventHandlerRoutine,	/// handler function
		true						///BOOL Add // add or remove handler
    );
	
	
	server_main();
	
	
	
	//deinit_memory_pool();					///will be done automatically
	
	
	exit_progress = -1;
	
}



#endif

												
												 
												 
												 
												 
#endif //#ifndef BSMART_SERVER_H												 